TS.Modules.dropdownList  = {
  moduleName: 'dropdownList',
  // CONFIG
  config: {},
  autoInit: true,
  navigator: null,
  focusGraph: null,
  init: function(){
	
		loadCss(TS.Config.Path.Style + 'dropdownList.css');
		
		TS.Modules.dropdownList = function(pItems,pSelected){
		
			/**
			* private properties
			*/
			var items = pItems || [];
			var selectedIndex = pSelected && pItems && pItems.length > pSelected ? pSelected : 0;
			var view = null;
			this.focusGraph = new TS.Modules.focusController.FocusGraph;
			
			
			/**
			* ::selectedIndex([setIndex])
			* set and gets the selectedIndex property. It also calls this.changed() if changed.
			*/
			this.selectedIndex = function(index,noPropagation)
			{
				if(index!==undefined && index >= 0 && index < items.length )
				{
					selectedIndex = index;
					if(noPropagation!==false)
						this.changed();
				}

				return selectedIndex;
			};
			
			
			/**
			* ::key([index])
			* returns with the key of the element at index or selectedIndex
			*/
			this.key = function(index)
			{
				if(parseInt(index) >= items.length)
					return false;
				
				index===undefined && (index=selectedIndex);

				var item = items[parseInt(index)];
				return typeof(item.key)!='undefined' ? item.key : parseInt(index || selectedIndex);
			};


			/**
			* ::value([index])
			* returns with the value of the element at index or selectedIndex
			*/
			this.value = function(index)
			{
				if(parseInt(index) >= items.length)
					return false;
				
				index===undefined && (index=selectedIndex);

				var item = items[parseInt(index)];
				return typeof(item)!='undefined' && typeof(item.value)!='undefined' ? item.value : item;
			};


			/**
			* ::push(item)
			* pushed the new item into the end of the list. Chainable.
			*/
			this.push = function(item)
			{
				items.push(item);
				view && this.display();
				return this;
			};


			/**
			* ::foreach(fn)
			* iterates thru the list wih fn.
			*/
			this.foreach = function(fn)
			{
				for(i=0;i<items.length;i++)
					fn.call(this,i,items[i]);
			};

			
			/**
			* private generateItemString()
			* returns with the up-to-date itemString.
			*/
			var generateItemString = function(){
			  var upSignTemplate = '<div class="upSign"><div class="sprite-dropdown-upSign"></div></div>';
			  var downSignTemplate = '<div class="downSign"><div class="sprite-dropdown-downSign"></div></div>';
				var itemString = upSignTemplate + downSignTemplate;
				this.foreach(function(i){itemString+='<'+TS.Modules.dropdownList.itemTag+' href="#">'+this.value(i)+'</'+TS.Modules.dropdownList.itemTag+'>'});
				
				  
				return itemString;
			};
     

			/**
			* private refreshFocusMap()
			* keeps the focusmap up-to-date
			*/
			var refreshFocusMap = function(closed){
				var map = {
					caption:{
						element : $('.caption a',view)
					},
					initial : 'caption'
				};
				
				if(!closed)
				{				
					var lastItem = 'caption';
					this.foreach(function(i){
						map[lastItem].down = 'item'+i;
						map['item'+i] = {element:$('.dropdown '+TS.Modules.dropdownList.itemTag+':eq('+i+')',view),up:lastItem}; 
						lastItem = 'item'+i;
					});
					map[lastItem].down = 'caption';
					map['caption'].up = lastItem;
				}

				this.focusGraph.setMap(map);
			}.bind(this);


			/**
			* ::display(parentNode)
			* shows the list for the first time - refreshes after it.
			*/

			this.display = function(parent,width,height){
				var me = this;
				this.maxHeight = height || 410;
        
				if(!view)
				{
					view = new View(TS.Modules.dropdownList.template,parent);
					view.set('caption', this.value());

					view = view.display().width(width);
					$('.caption a span',view).width(width-72);
					
					view.show().children().keydown(function(event){
						if(event.which==TS.KeyCodes.back && me.isOpen())
						{
							console.info('me close');
							me.close(event);
							event.stopPropagation();
						}

						if(this==$('.dropdown')[0])
							window.setTimeout(function(){$('.dropdown',view)[0].scrollTop = $('.dropdown a.focus').prevAll('.dropdown a').length*$('.dropdown a.focus').height()},10);
						else
						{
							var top = event.which==TS.KeyCodes.downArrow ? 0 : $('.dropdown a:last',view).offset().top;
							window.setTimeout(function(){$('.dropdown',view)[0].scrollTop = top;},10);
						}
					});

					$('.caption a',view).click(function(){
						if($('.dropdown:visible',view).length)
						{
							me.close(e);
						}else{
							me.open();
						}
					});

					// mousewheel handling
					$('.dropdown',view).on('mousewheel wheel',function(e){
						$('.dropdown',view)[0].scrollTop -= e.originalEvent.wheelDeltaY;
					});

					refreshFocusMap('closed');
					this.focusGraph.setElement($(view));
				}
				$('.dropdown',view).width(view.width()).html(generateItemString.call(this));
				$('.dropdown '+TS.Modules.dropdownList.itemTag,view)
					.each(function(index){ $(this).data('listProperties',{index:index,key:me.key(index),value:me.value(index)}); })
					.click(function(){
						me.selectedIndex($(this).data('listProperties').index);
						$(me).trigger('select');
					});
				me.selectedIndex(me.selectedIndex(),false);
			
			
			//set start states of up/down signs
			    $('.downSign',view).css('width',width);
          $('.upSign',view).css('width',width);    
        
          setTimeout(function(){  
            if( items.length * 45  < 410){
               $('.downSign',view).css('display','none');
               $('.upSign',view).css('display','none');  
            }
            else{
                $('.downSign',view).css('display','block');     
            }
          },100);

				/*
				* up and down sign for showing possible scroll directions 
				*/
				var onScroll = function(){
					console.info('onScroll');
				  var contentHeight = items.length * parseInt($(".dropdownList .dropdown a").height());
				  var containerHeight =  410;//parseInt($(".dropdownList .dropdown").height());
	  
					//up sign
					if($('.dropdown',view)[0].scrollTop != 0){
						$('.upSign',view).css('display','block');
					}
					else{
						$('.upSign',view).css('display','none');
					};

					//down sign
					if($('.dropdown',view)[0].scrollTop < contentHeight - containerHeight){
						$('.downSign',view).css('display','block');
					}
					else{
						$('.downSign',view).css('display','none');
					};
				};
				$('.dropdown',view).on('scroll',onScroll);

				var autoScroll = function(){
					$('.dropdown',view)[0].scrollTop += (this.className.indexOf('downSign')>=0 ? 1 : -1)*30;
					autoScroll.timeout = setTimeout(autoScroll.bind(this),100);
				};
				$('.downSign,.upSign',view)
					.mouseover(autoScroll)
					.mouseout(function(){autoScroll.timeout && clearTimeout(autoScroll.timeout)});
			};


			/**
			* ::isOpen()
			*/
			this.isOpen = function(){
				return Boolean($('.dropdown:visible',view).length);
			}


			/**
			* ::changed()
			*/
			this.changed = function(){
				$('.caption a span',view).html(this.value());
				$(this).trigger('change');
				this.close();
			}


			/**
			* ::open()
			*/
			this.open = function(){
				refreshFocusMap();
				$('#ddlShadow')[0].ddList = this;
				$('.caption a',view).css({position:'absolute',zIndex:99});
				$('#ddlShadow').show();
				$('.dropdown a.focus',view).removeClass('focus');
				var me = this;
				//$('.dropdown',view).stop().slideDown(TS.Modules.dropdownList.ROLL_TIME,function(){focusGraph.focus();});
				
				$('.dropdown',view).css({height: '', overflowY:''});
				$('.dropdown',view).show();

				if($('.dropdown',view).height() > this.maxHeight)
					$('.dropdown',view).css({height: this.maxHeight, overflowY:'hidden'});

				if(this.selectedIndex())
				{
					window.setTimeout(function(){
						me.focusGraph.setFocused($('.dropdown a:eq('+me.selectedIndex()+')',view));
						$('.dropdown',view)[0].scrollTop = $('.dropdown a.focus').prevAll('.dropdown a').length*$('.dropdown a.focus').height()},10);
						$(view).trigger('scroll');
				}
				this.focusGraph.setFocused();

				$(this).trigger('rolldown');
			};


			/**
			* ::close()
			*/
			this.close = function(e){
				refreshFocusMap('closed');
				//$('.dropdown',view).stop().slideUp(TS.Modules.dropdownList.ROLL_TIME);
				$('.caption a',view).css({position:'relative',zIndex:''});
				$('.dropdown',view).hide();
				$('#ddlShadow').hide();
				this.focusGraph.setFocused($('.caption a',view));
				$(this).trigger('rollup');
				window.samsung.widgetAPI.blockNavigation(e);
			}
			
			
			this.reset = function(){
				view = null;
				items = [];
				selectedIndex = 0;
			}
			
			this.hide = function(){
				if(view && view.remove)
					view.remove();
				view = null;
			}
		};
		
		/**
		* static properties
		*/
 
		TS.Modules.dropdownList.template = loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix);
		TS.Modules.dropdownList.itemTag = 'a';
		TS.Modules.dropdownList.ROLL_TIME = 400;

		$(document.body).append($('<div id="ddlShadow"></div>'));
		$('#ddlShadow').click(function(){this.ddList && this.ddList.close();$(this).hide()});
  }
};
