'use strict';

TS.Modules.livematchcentre = {
	moduleName: 'livematchcentre',
	autoInit: true,
	config: {},
  navigator: null,
	focusGraph : null,
	competitionID : null,
  requires: ['resultsfixtures', 'tables', 'goalFeeds'],
  
	init: function(){

    // delay init until feeds are ready
    if (!TS.Modules.goalFeeds.isReady) {
      $(TS.Modules.goalFeeds).on('ready', this.init.bind(this));
      return;
    }
	  
    // create the view and load the css
    loadCss(TS.Config.Path.Style + 'livematchcentre.css');
    
    /*
    // Back to home
    var backToHome = function(){
      TS.Modules.video.hide();
    };
    
    var backToHomeRemote = function(event) {
      if (event.which == TS.KeyCodes.stop){
        hideVideo();
      }
    }
    
    $(document.body).keydown(hideVideoRemote);
    
    backButton.unbind('click');
    backButton.bind('click', function(){
      hideVideo();
    });
    */

		var view = new View(loadTemplate(TS.Config.Path.Modules + 
     		 								this.moduleName + '/' + 
     		 								this.moduleName + 
     		 								TS.Config.templateSuffix), 
     		 								'#section-content'),
		    viewRef = null,
		    lastTab = 'results',
		    ddList = new TS.Modules.dropdownList,
		    competitionFeed = TS.Modules.goalFeeds.competitionsFeed,
		    childModules = {
		    	results  : TS.Modules.resultsfixtures,
		    	fixtures : TS.Modules.resultsfixtures,
		    	tables   : TS.Modules.tables
		    };

		var urlFrom = function(tab){
			return tab.indexOf('tables')>-1 && '/resultsfixtures/tables#to=tables' || '/resultsfixtures#to='+tab;
		};

    TS.Modules.livematchcentre.competitionID = competitionFeed.defaultID;

		$(competitionFeed).on('change',function(e,response){
			for(var i=0;i<response.processedResponse.length;i++) {
		    ddList.push({key:response.processedResponse[i].id,value:response.processedResponse[i].name});
        if (response.processedResponse[i].id === TS.Modules.livematchcentre.competitionID) {
          ddList.selectedIndex(i, false);
        }
      }

		}.bind(this));
		competitionFeed.pull();

		$(ddList).on('change',function(){
			TS.Modules.livematchcentre.competitionID = this.key();
			TS.Modules.livematchcentre.navigator.navigate(urlFrom(lastTab));
			TS.Modules.livematchcentre.setTab(lastTab);
		});

												
		this.focusGraph = new TS.Modules.focusController.FocusGraph();
		var focusMap = {
			initial : 'tabs',
			tabs : {
				element: new TS.Modules.focusController.FocusGraph(),
				down: 'content',
				left: 'ddList'
			},
			content : {
				element: TS.Modules.tables.focusGraph,
				up: 'tabs'
			},
			ddList : {
				element: ddList.focusGraph,
				right: 'tabs',
				down : 'content'
			}
		};
		var tabMap = {
			initial : 'tab0'
		};


		
		for(var i=0;i<3;i++)
		{
			tabMap['tab'+i] = {element: null};
			i && (tabMap['tab'+i].left = 'tab'+(i-1));
			i<2 && (tabMap['tab'+i].right = 'tab'+(i+1));
		}
		
		/**
		 * Changes the language elements.
		 * 
		 * @return void
		 */
		var initTexts = function(){
			
			  // title
			  view.set('livematchcentre_page_title', $.translate('livematchcentre_page_title'));
		     // tabs
		      view.set('results_tab_title', $.translate('results_tab_title'));
		      view.set('fixtures_tab_title', $.translate('fixtures_tab_title'));
		      view.set('tables_tab_title', $.translate('tables_tab_title'));
		}.bind(this);

		
		
		var initFocusGraph = function(){
			var i = 0;
			$('#LMC_tabs li>a',viewRef).each(function(){
				tabMap['tab'+(i++)].element = $(this)
					.click(function(){
						$('#LMC_tabs li>a.selected',viewRef).removeClass('selected');
						$(this).addClass('selected')
					});
			});
			focusMap.tabs.element.setElement($('#LMC_tabs')).setMap(tabMap);
			this.focusMap = focusMap;
			this.focusGraph.setElement(viewRef).setMap(focusMap);
        
      TS.Modules.focusController.root.changeElement('content',this.focusGraph);
        
		}.bind(this);
		
		/**
		 * Inits the navigation and binds the specific event handlers
		 * 
		 * @return	void
		 */
		var initNavigation = function(){
			this.navigator = new TS.Modules.navigationController.Navigator('livematchcentre',this);
	    this.navigator.addChildren(
	      TS.Modules.resultsfixtures.navigator
	    ).setDefault(TS.Modules.resultsfixtures.navigator);

		  $(this.navigator).on('childOpen', childShow);
		  $(this.navigator).on('childClose',hide);
		}.bind(this);
    
    /**
     * Handles the navigation CHILDOPEN event
     * 
     * @param event (Object)
     * @param eventData (Object)
     * 
     * @return void
     */
    // var overloadBackEvent = function(event){
    	// if(event.which == TS.KeyCodes.back)
    	// {
        // console.log('TS.Modules.navigationController.root.activeUrl  ----> '+TS.Modules.navigationController.root.activeUrl);
        // console.log(TS.Modules.navigationController.root.activeUrl.indexOf('tables')<0);
        // console.log('LAST TAB: '+lastTab);
        
    		// if( TS.Modules.navigationController.root.activeUrl.indexOf('resultdetailed')<0 && lastTab == 'results' ) {
	    		// TS.Modules.navigationController.root.navigate('/');
          // console.log('A');
        // }
	    	// else
	    	// {
	    		// $(TS.Modules.resultsfixtures.navigator).trigger('open');
					// TS.Modules.livematchcentre.navigator.navigate(urlFrom(lastTab));
					// TS.Modules.livematchcentre.setTab(lastTab);
          // console.log('B');
				// }

	    	// event.stopPropagation();
    	// }
    // };

    var childError = function(){
	    Preloader.hide();
	    TS.Modules.noticeWindow.alert({
	      title: $.translate('error_pageError'),
	      text: $.translate('error_pageContents'),
	      yesButton: {
	        buttonLabel: $.translate('label_Ok'),
	        callback: function(){TS.Modules.navigationController.root.navigate('/')}
	      }
	    });
    };

    var childShow = function(event, eventData) {   
    	// $('#app-wrapper').off('keydown',overloadBackEvent).on('keydown',overloadBackEvent);
    	lastTab = eventData && eventData.hashVars.to || 'results';
      // console.dir( eventData );

    	$([TS.Modules.resultsfixtures,TS.Modules.tables]).override('error','LMC_Error',childError);

			if(!$('div#livematchcentre').length)
			{
				// console.info('first show');
				// clear the parent container
				// $('#section-content').html('');
				initTexts();
				// show the view
				viewRef = view.display()
				$( viewRef ).show();
       
				initFocusGraph();
				// console.log( 'childShow lastTab:  '+lastTab);
				this.setTab(lastTab);
			}
		

			if (eventData && eventData.url.indexOf('resultdetailed') === -1)
      {
        ddList.hide();
        ddList.display('#livematchcentre .ddList',300);
        // add ddlist to left from focusGraph
        this.focusMap.tabs.left = 'ddList';
      }
			else {
				ddList.hide();
        // remove ddlist from left from focusGraph
        this.focusMap.tabs.left = null;
      }
    }.bind(this);
		
	
		this.setTab = function(selectedTab)
		{
			var i,j=0;
			for(i in childModules)
			{
				if(i==selectedTab)
					focusMap.tabs.element.setFocused($('#LMC_tabs li a:eq('+j+')',viewRef));
				j++;
			}			

			$('#LMC_tabs li>a.selected',viewRef).removeClass('selected'); 
			$('#LMC_tabs li>a.' + selectedTab).addClass('selected'); 
			TS.Modules.focusController.root.blur();
			TS.Modules.livematchcentre.focusGraph.setFocused();
    	if(TS.currentLang==='es'){ // very nasty hack
    	  $('#LMC_tabs li>a').addClass('short');
    	}
		};
		
		/** 
     * Handles the navigation CLOSE event
     * 
     * @return void
     */
    var hide = function(event, data) {
      // $(TS.Modules.resultsfixtures).override('ready','resultsfixturesReady');
      // $(TS.Modules.tables).override('ready','tablesReady');
      
      // $([TS.Modules.resultsfixtures,TS.Modules.tables]).override('error','LMC_Error');
      // console.log('LMC HIDE');
      
      
      // $('#app-wrapper').off('keydown',overloadBackEvent);
      $('#section-content').html('');
      ddList.hide();
      viewRef = null;
    }.bind(this);
    
    initNavigation();
    
    $(TS.Modules.resultsfixtures).override('ready', 'resultsfixturesReady',function(){$(TS.Modules.livematchcentre).trigger('ready')});
    $(TS.Modules.tables).override('ready', 'tablesReady',function(){$(TS.Modules.livematchcentre).trigger('ready')});

    
	// TEST
	}
	
};
