TS.Modules.results = {
	moduleName : 'results',
	autoInit : false,
	config: {},
	focusGraph: null,
  navigator: null,
  requires: ['goalFeeds'],
	init : function(){
    this.navigator = new TS.Modules.navigationController.Navigator('result');

		loadCss(TS.Config.Path.Style + 'results.css');
		var view = new View(loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix), '#section-lmc-content');
		
    var show = function() {
      // init textfields
      view.set('detailed_livecommentary_title', $.translate('detailed_livecommentary_title'));
      
      var viewRef = view.display();
      
      var homeTeamName = $('#livematchcentre-results .home .team-name');
      var awayTeamName = $('#livematchcentre-results .away .team-name');
      var homeScore = $('#livematchcentre-results .home .score');
      var awayScore = $('#livematchcentre-results .away .score');
      
      var homeSubPlayers = $('#livematchcentre-results .home .subs');
      var awaySubPlayers = $('#livematchcentre-results .away .subs');
      
      
      
      
      var fillComments = function(){
        var lineNumber = 0;
        var commentElem = [];
          
        for(var i=0; i<11; i++){
          commentElem.push([
            {key:'time', value: lineNumber++},
            {key:'comment', value: 'comment'}
          ]);
          
        }
          
        view.foreach(commentElem, '#lmc-dr-commentline');
      }
      
      var setHomeScore = function(score){
        homeScore.text(score);
      }
      
      var setAwayScore = function(score){
        awayScore.text(score);
      }
      
      var fillHomeMembers = function(){
        var members = [];
        
        var lineNumber = 0;
        
        for( var i=0; i<11; i++){
          members.push([
            {key:'playernumber',value:lineNumber++},
            {key:'playername',value:'Hazai Béla_' + lineNumber.toString()},
            {key:'card', value: lineNumber % 3 == 0 ? 'none' : lineNumber % 3 == 1 ? 'red' : 'yellow'}
          ]);
        }
        
        view.foreach( members, '#lmc-dr-home-member');
      }
      
      var fillAwayMembers = function(){
        var members = [];
        var lineNumber = 0;
        
        for ( var i=0; i<11; i++){
          members.push([
            {key:'playernumber',value:lineNumber++},
            {key:'playername',value:'Ellenség Tibor_' + lineNumber.toString()},
            {key:'card', value: lineNumber % 3 == 0 ? 'none' : lineNumber % 3 == 1 ? 'red' : 'yellow'}
          ]);
        }
        
        view.foreach( members, '#lmc-dr-away-member');
      }
      
      var setHomeTeamName = function( name ){
        homeTeamName.text( name );
      }
      
      var setAwayTeamName = function( name ){
        awayTeamName.text( name );
      }
      
      var setHomeSubPlayers = function( names ){
        homeSubPlayers.text( names.join(', ') );
      }
      
      var setAwaySubPlayers = function( names ){
        awaySubPlayers.text( names.join(', ') );			
      }
      
      
      fillComments();
      setHomeScore(3);
      setAwayScore(1);
      fillHomeMembers();
      fillAwayMembers();
      setHomeTeamName('Home');
      setAwayTeamName('Away');
      setHomeSubPlayers(['Hazai Váltás_1', 'Hazai Váltás_2', 'Hazai Váltás_2']);
      setAwaySubPlayers(['Ellenség Váltás_1', 'Ellenség Váltás_2', 'Ellenség Váltás_2']);
      
      $(viewRef).show();
    };

    var hide = function() {
      $('#section-lmc-content').html('');
    };

    $(this.navigator).on('open', show);
    $(this.navigator).on('close', hide);
  }
}
