TS.Modules.resultsfixtures = {
  moduleName : 'resultsfixtures',
  autoInit : true,
  config : {},
  focusGraph : null,
  navigator : null,
  errorState: 0,
  requires: ['navigationController', 'resultdetailed', 'focusController', 'goalFeeds'],

  init : function() {

    // delay init until feeds are ready
    if (!TS.Modules.goalFeeds.isReady) {
      $(TS.Modules.goalFeeds).on('ready', this.init.bind(this));
      return;
    }
    
    // create the view and load the css
    // loadCss(TS.Config.Path.Style + 'resultsfixtures.css');
    var view = new View(loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix), '#section-lmc-content');

    /**
     * Inits the navigation and binds the specific event handlers
     *
     * @return	void
     */
    var initNavigation = function() {
      this.navigator = new TS.Modules.navigationController.Navigator('resultsfixtures', this);

      this.navigator.addChild(TS.Modules.resultdetailed.navigator,TS.Modules.tables.navigator);

      $(this.navigator).on('open', this.show);
      $(this.navigator).on('close', this.hide);

    }.bind(this);

    var viewRef;

    var resultsShowed = true;//if results or fixtures to display
    var thumbPreLoader = 0;

    var dates = [];//local holders of the date objects 
    var datesPerPage = 8; // the number of the displayed dates on the dates line
    var dateIndexOnThumb = 0;// index of the date on the thumb
    var datesOffset = 0;// offset on the date thumbs from the beginning of the date data
    var actDateIndex = function() {// index inside the the dates data array (index in date data: datesOffset + dateIndexOnThumb)
      return datesOffset + dateIndexOnThumb + 1;
    }.bind(this);

    var indexOfFirstFixture = 0;// index of today's date in the date data

    var datesFeed = new TS.Modules.MatchesFeed;

    var actGames = [];
    var actGamesPageIndex = 0;

    var datesElementArray = [];
    var gamesElementArray = [];
    var leftArrow;
    var rightArrow;
    
    var forceDatesReset = false;

    /// load and build -------------------------------------------------------------------
  
    $(datesFeed).on('ready',function() {
      drawDates(forceDatesReset);
    });
    $(datesFeed).override("error","resutlsfixturesErrorHandler",function(){popError()}.bind(this));

    // pull Dates data
    function loadDates() {
      dates = [];
      $(datesFeed).override("error","resutlsfixturesErrorHandler",function(){popError()}.bind(this));
      datesFeed.pullDates(TS.Modules.livematchcentre.competitionID);
    }
	
	function popError() {
		Preloader.hide();
		TS.Modules.noticeWindow.alert({
			title: $.translate('error_pageError'),
			text: $.translate('error_pageContents'),
			yesButton: {
			buttonLabel: $.translate('label_Ok'),
			callback: function(){TS.Modules.navigationController.root.navigate('/')}
			}
		});
	}


    // rendering dates ---------------------------------------------------------------------
    function drawDates(forceDatesReset) {
      $(datesFeed).override("error","resutlsfixturesErrorHandler");

      ///getting the indexOfFirstFixture

      dates = datesFeed.dates;
      indexOfFirstFixture = dates.length - datesPerPage; // if theres no fixture, it will be the default
      
      for(var i = 0; i < dates.length ; i++)
      {
        if(!dates[i].hasResult)
        {
          indexOfFirstFixture = i;
          break;
        }
      }

      //handling dates structure according to if result or fixture
      var foreachDates = [];

      var from;
      var to;

      //if results showed
      if(resultsShowed){
        if(indexOfFirstFixture - datesPerPage < 0){
          from = 0;
          to = datesPerPage - 1;
          dateIndexOnThumb = datesPerPage - indexOfFirstFixture;
          datesOffset = 0;
        }
        else{
          
          if (forceDatesReset) {
          
            from = indexOfFirstFixture - datesPerPage;
            to = indexOfFirstFixture - 1;
            dateIndexOnThumb = datesPerPage - 1;
            datesOffset = indexOfFirstFixture - datesPerPage - 1;
            
          } else {
            
            from = datesOffset + 1;
            to = datesOffset + datesPerPage;
            
          }
          
          
        } 
      }

      //if fixtures showed
      else{
        actGamesPageIndex = 0;
        if(indexOfFirstFixture + datesPerPage > dates.length){
          var diff = dates.length - indexOfFirstFixture;
          from = dates.length - datesPerPage;
          to = dates.length - 1;
          dateIndexOnThumb = datesPerPage - diff;
          datesOffset = dates.length - datesPerPage;
        }
        else{
          from = indexOfFirstFixture;
          to = indexOfFirstFixture + datesPerPage - 1;
          dateIndexOnThumb = 0;
          datesOffset = indexOfFirstFixture-1;
        }
      }

      //render dates line if first load
      if($("#livematchcentre-resultsfixtures .dateHolder").length == 1){
            for( i = from; i <= to; i++) {
              var selected = (resultsShowed)
              var foreachElem = [{
                key : 'dayMonth',
                value : dates[i].dayMonth
              }];
      
              foreachDates.push(foreachElem);
            }
      
            view.foreach(foreachDates, '#lmc-fixtures-date-list');
            
            datesElementArray.splice(0);
            
            for( i = 0; i < datesPerPage; i++) {
              var dateElem = $("#livematchcentre-resultsfixtures .dateHolder").children().eq(i);
              datesElementArray.push(dateElem);
           
              dateElem.click(onDateClick).data('index',i);
            }
      }
      
      //set selected date-gfx
      datesElementArray[dateIndexOnThumb].addClass("selected");

      $("#livematchcentre-resultsfixtures .dateHolder").hide();
      setTimeout('$("#livematchcentre-resultsfixtures .dateHolder").show()',10);

      loadGames();
    }

    // update Dates (pagin)
    function updateDate() {
      for(var i = 0; i < datesPerPage; i++) {
        var index = i + datesOffset + 1;
        datesElementArray[i].children('p.dayMonth').text(dates[index].dayMonth);
      }
    }

    // pull Games datas
    var loadGames = function() {
      
      actGames = dates[actDateIndex()];
      $(actGames).on('ready',drawGames);
      $(actGames).override("error","resutlsfixturesErrorHandler",function(){popError();}.bind(this));
      actGames.pullMatches();
    }.bind(this);

    // rendering game thumbs -----------------------------------------------
    function drawGames() {
      $(actGames).override("error","resutlsfixturesErrorHandler");
      this.debug && $.trace.log('DrawGames');    
      thumbPreLoader && thumbPreLoader.clear();
      thumbPreLoader = new TS.Modules.multiPreloader({showOnAllReady : true});

      //1st load, create gamesThumb if not rendered -------------------------------------------     
      if($('.gamesHolder .gameElem').length == 1) {
        createGameElements();
      }

      // fill with content
        var resultContent = "results";


        /// iterate on all 6 game thumbItems -------------------------------------------------------
        for(var i = 0; i < 6; i++) {

          var index; //index on the dates array
          
          //whole page turn
          if((actGamesPageIndex + 1) * 6 < actGames.gamesCount) {
            index = actGamesPageIndex * 6 + i;
          }
          //fractual turn
          else {
                index = actGamesPageIndex * 6 + i;
          }
        
        // if there is data on the item
        if(typeof actGames.resultsFixtures[index] != "undefined"){
            var homeTeamName = actGames.resultsFixtures[index].homeTeam.name;
            var homeTeamLogo = thumbPreLoader.add(actGames.resultsFixtures[index].homeTeam.logo.url);
            var awayTeamName = actGames.resultsFixtures[index].awayTeam.name;
            var awayTeamLogo = thumbPreLoader.add(actGames.resultsFixtures[index].awayTeam.logo.url);
            var homeScore = isNaN(actGames.resultsFixtures[index].homeTeam.score) ? '?' :
                            actGames.resultsFixtures[index].homeTeam.score;
            var awayScore = isNaN(actGames.resultsFixtures[index].awayTeam.score) ? '?' :
                            actGames.resultsFixtures[index].awayTeam.score;
            var minutes = (actGames.resultsFixtures[index].kickoff.getMinutes()== 0) ? "00" : actGames.resultsFixtures[i].kickoff.getMinutes();
            var time = actGames.resultsFixtures[index].kickoff.getHours() + ":" + minutes;
  
  
            //decide if fixture or result  
            if(actGames.resultsFixtures[index].type == "fixture") {
              gamesElementArray[i].
                removeClass('result').
                addClass('fixture').
                prop('currentResult', null).
                prop('currentDate', null).
                prop('matchDateIndex', null)
                
               resultContent = "fixtures";
            } else {
              // hack
              gamesElementArray[i].currentDate = actGames;
              gamesElementArray[i].currentResult = actGames.resultsFixtures[index];
              gamesElementArray[i].matchDateIndex = index;

              gamesElementArray[i].
                addClass('result').
                removeClass('fixture').
                prop('currentResult', actGames.resultsFixtures[index]).
                prop('currentDate', actGames).
                prop('matchDateIndex', index)
                
                resultContent = "results";
            }
            
            /// update template fields by datas
  
            gamesElementArray[i].find('.home').text(homeTeamName);
            gamesElementArray[i].find('.away').text(awayTeamName);
  
            gamesElementArray[i].find('.homelogo').attr('src', homeTeamLogo);
            gamesElementArray[i].find('.awaylogo').attr('src', awayTeamLogo);
  
            gamesElementArray[i].find('.homeScore').text(homeScore);
            gamesElementArray[i].find('.awayScore').text(awayScore);

            gamesElementArray[i].find('.time').text(time);
             
            gamesElementArray[i].css('display','block');          
          }
          
         // if there is no data on the item, generate empty thumb -------------------------
          else {
           gamesElementArray[i].css('display','none');
          }
        }
        
        updateGamesFocus();
        
        setArrowsDisabledStates();
        
        TS.Modules.livematchcentre.setTab(resultContent);
        TS.Modules.navigationController.updateLinks();
  
        thumbPreLoader.preLoad();
        $(viewRef).show();
        $(TS.Modules.resultsfixtures).trigger('ready');
    };
    

    //rendering gameThumbs on first build
    function createGameElements(){
       foreachGames = [];
       for( i = 0; i < 6; i++) {
          foreachElem = [
              {
                key : 'matchID',
                value : ""
              }, {
                key : 'homeTeamName',
                value : ""
              }, {
                key : 'homeLogo',
                value : '<img class="homelogo" src="i/GoalApp/preloader.gif"/>'
              }, {
                key : 'time',
                value : ""
              }, {
                key : 'homeScore',
                value : "0"
              }, {
                key : 'awayScore',
                value : "0"
              }, {
                key : 'awayTeamName',
                value : ""
              }, {
                key : 'awayLogo',
                value : '<img class="awaylogo" src="i/GoalApp/preloader.gif"/>'
              }, {
                key : 'linkClass',
                value : "result"
              }
            ];          
          foreachGames.push(foreachElem);  
       }
       
        view.foreach(foreachGames, '#lmc-fixtures-team-list');
        
        $('#livematchcentre-resultsfixtures .gameElem > a').
          override('click','gameClick', function(event) {
            if (event.currentTarget.currentResult) {
              
              console.log('event.currentTarget.currentDate');
              console.log(event.currentTarget.currentDate);
              console.log(event);
              
              TS.Modules.navigationController.root.navigate(
                '/livematchcentre/resultsfixtures/resultdetailed', {
                  currentResult: event.currentTarget.currentResult,
                  matchDateIndex: event.currentTarget.matchDateIndex,
                  matchDate: event.currentTarget.currentDate
                });
            }
          });

        gamesElementArray.splice(0);
        for(var i = 0; i < 6; i++) {
          //create dom element vars
          var gameElem = $("#livematchcentre-resultsfixtures div.team-list .gamesHolder").children().eq(i).children();
          gamesElementArray.push(gameElem);
          //not to display if there no content
          /*if(foreachGames[i][0].value == "")
            gameElem.css("display","none");*/
        }
        createFocusGraph();
    }
    
    //	paginations ---------------------------------------------------------------------------

    function initPagination () {
    
      var turnLeft = function() {

        if(actDateIndex() == 0)
          return;

        //load prev Date
        if(actGamesPageIndex == 0) {
          if(dateIndexOnThumb == 0 && datesOffset == 0)
            return;
          else {
            if(datesOffset == actDateIndex() - 1) {
              dateIndexOnThumb = 1;
              datesOffset--;
              actGamesPageIndex = 0;
              updateDate();
            }
          }
          dateIndexOnThumb--;
          loadGames();
          setActDate();
        }
        //load prev page inside the date
        else {
          actGamesPageIndex--;
          drawGames();
        }
      }

      var turnRight = function(event) {
        //load next Date
        if(actGamesPageIndex == Math.ceil((dates[actDateIndex()].gamesCount) / 6) - 1) {

          if(actDateIndex() == dates.length - 2)
            return;

          if(dateIndexOnThumb == datesPerPage - 1) {
            dateIndexOnThumb--;
            datesOffset++;
            updateDate();

          }
          dateIndexOnThumb++;
          actGamesPageIndex = 0;
          loadGames();
          setActDate();
        }
        //load next Page inside the date
        else {
          actGamesPageIndex++;
          drawGames();
        }
      }.bind(this);


      leftArrow.click(turnLeft);
      rightArrow.click(turnRight);

    }
    /// handling click on the dateLine
    var onDateClick = function() {
      dateIndexOnThumb = parseInt($(this).data('index'));
      actGamesPageIndex = 0;
       
      setActDate();
      loadGames();
    };

    //set selection gfx
    function setActDate() {
      $("#livematchcentre-resultsfixtures .dateHolder").children().removeClass('selected');
      datesElementArray[dateIndexOnThumb].addClass('selected');
    }

    // Set disabled states on arrows
    function setArrowsDisabledStates(){
      // leftArrow    
      if(actDateIndex() == 1){
        leftArrow.addClass("disabled");
        map.dates.left = null;
        map.games.left = null;
       
      }
      else {
        leftArrow.removeClass("disabled");
        map.dates.left = 'left';
        map.games.left = 'left';
      }
      
      // rightArrow
      if(
        actDateIndex() == dates.length - 2 &&
        actGamesPageIndex == Math.ceil((dates[actDateIndex()].gamesCount) / 6) - 1
        ){
          rightArrow.addClass("disabled");
          map.dates.right = null;
          map.games.right = null;
        }
        else{
          rightArrow.removeClass("disabled");
          map.dates.right = 'right';
          map.games.right = 'right';
        }
    }

    /// 	FocusHandling -------------------------------------------------------

    this.focusGraph = new TS.Modules.focusController.FocusGraph();
    var dateGraph = new TS.Modules.focusController.FocusGraph();
    var gameGraph = new TS.Modules.focusController.FocusGraph(true);
    
    var map = {};
    var createFocusGraph = function() {

      map.initial = 'dates';

      //arrows
      map.left = {
        element : leftArrow,
        right : 'games',
        up : 'dates'
      }
      map.right = {
        element : rightArrow,
        left : 'games',
        up : 'dates'
      }

      //dates
      var dateMap = {};
      for(var i = 0; i < datesPerPage; i++) {
        var focusElem = {};
        focusElem.element = datesElementArray[i];
        if(i != 0) {
          var prev = i - 1;
          focusElem.left = 'dateNode' + prev;
        } 

        if(i != datesElementArray.length - 1) {
          var nxt = i + 1;
          focusElem.right = 'dateNode' + nxt;
        } 

        dateMap['dateNode' + i] = focusElem;
      }
      
      dateMap.initial = (!resultsShowed) ? "dateNode0" : "dateNode7";
      dateGraph.setElement($('#livematchcentre-resultsfixtures .dateHolderBackground')).setMap(dateMap);
      map.dates = {
        element: dateGraph,
        down:'games',
        left: 'left',
        right:'right'
      };

      //games
      var gameMap = {};
      for(var i = 0; i < 6; i++) {
        var focusElem = {};
        focusElem.element = gamesElementArray[i];

        //left-right
        if(i < 3) {
          var rightIndex = i + 3;
          focusElem.right = 'gameNode' + rightIndex;

        } else {
          var leftIndex = i - 3;
          focusElem.left = 'gameNode' + leftIndex;
        }

        // up
        if(i != 0 && i != 3) {
          var upIndex = i - 1;
          focusElem.up = 'gameNode' + upIndex;
        }
        //down
        if(i != 5) {
          var downIndex = i + 1;
          focusElem.down = 'gameNode' + downIndex;
        }

        gameMap['gameNode' + i] = focusElem;
      }

      gameMap.initial = "gameNode0";
      gameGraph.setElement($('#livematchcentre-resultsfixtures div.team-list')).setMap(gameMap);
      map.games = {
        element: gameGraph,
        left: 'left',
        right:'right',
        up: 'dates'
      };

      // put together
      this.focusGraph.setElement($('#livematchcentre-resultsfixtures')).setMap(map);
      TS.Modules.livematchcentre.focusGraph.changeElement('content',this.focusGraph);
/*      TS.Modules.focusController.root.blur();
      this.focusGraph.setFocused();*/
    }.bind(this);


    // update game-graph
    function updateGamesFocus(){

       var elementsOnPage;
       
       if((actGamesPageIndex + 1) * 6 <= actGames.gamesCount){
         elementsOnPage = 6;
       }
       else {
         elementsOnPage = actGames.gamesCount - (actGamesPageIndex) * 6 ;  
       }
  
        var gameMap = {};
        for(var i = 0; i < elementsOnPage; i++) {
          var focusElem = {};
          focusElem.element = gamesElementArray[i];
  
          //left-right
          if(i < 3) {
            var rightIndex = i + 3;
            if(rightIndex < elementsOnPage)
               focusElem.right = 'gameNode' + rightIndex;
  
          } else {
            var leftIndex = i - 3;
            focusElem.left = 'gameNode' + leftIndex;
          }
  
          // up
          if(i != 0 && i != 3) {
            var upIndex = i - 1;
            focusElem.up = 'gameNode' + upIndex;
          }
          
          //down
          if(i != 5) {
            var downIndex = i + 1;
            if(downIndex < elementsOnPage)
              focusElem.down = 'gameNode' + downIndex;
          }
          
          gameMap['gameNode' + i] = focusElem;
        }
        
        gameMap.initial = "gameNode0";
        
        ///  
        map.games.element.setMap(gameMap).setElement($('#livematchcentre-resultsfixtures div.team-list'));
    }

    /*
     handles SHOW event
     */

    this.show = function(event, eventData) {
      viewRef = view.display();
      
      
      forceDatesReset = eventData.hashvars && eventData.hashvars.forceDatesReset || false;
    
      if(eventData && eventData.hashvars && typeof eventData.hashvars.to != "undefined"){
          resultsShowed = (eventData.hashvars.to == "results") ? true : false;
        }
      else{
        resultsShowed = true; 
        }
          /// dom elements
          leftArrow = $("#livematchcentre-resultsfixtures a.previous");
          rightArrow = $("#livematchcentre-resultsfixtures a.next");
    
          ///
          initPagination();
          loadDates();
          
        }.bind(this);

    /** 
     * Trigger error dialog if resultsfixtures timeOut occures
     * 
     * [NOT FINISHED! 11.29.]
     * 
     * @return dialogBox
     */
    if(TS.Config.DEBUG){
      $(TS.Modules.resultsfixtures).override('error','resultsfixturesError', function(){
        TS.Modules.resultsfixtures.errorState = 1;
        this.popAlert();
        $(TS.Modules.resultsfixtures).trigger('ready');
      });
      
      this.popAlert = function(){
        var testAlert = {
            title: $.translate('live_match_center_load_error_title'),
            text: $.translate('live_match_center_load_error_text'),
            yesButton: {
              buttonLabel: $.translate('label_return'),
              callback: function(){
                return false;
              }
            },
            noButton: {
              buttonLabel: $.translate('label_wait'),
              callback: false
            }
          };
          TS.Modules.noticeWindow.alert(testAlert);
      };
    }
    /**
     * Handles the navigation CLOSE event
     *
     * @return void
     */
    this.hide = function() {
      $('#section-lmc-content').html('');
      thumbPreLoader && thumbPreLoader.clear();
    }.bind(this);

    /*
     fires init functions, run only once
     */

    initNavigation();

  }
};
