/**
 * Platform-specific options for LG NetCast browsers
 */

(function() {
  // override videoDisplay
  var i = TS.Include.indexOf('videoDisplay');
  if (i !== -1) {
    TS.Include[i] = 'videoDisplay.netcast';
  }

  // set key codes
  TS.KeyCodes = {
    leftArrow: 37,
    upArrow: 38,
    rightArrow: 39,
    downArrow: 40,
    back: 461,
    toggleConsole: 403,
    play: 415,
    stop: 413,
    pause: 19,
    rewind: 412,
    forward: 417,
    info: 457
  };

  if (TS.Config.DEBUG) {
    // load firebug
    document.write('<script src="https://getfirebug.com/firebug-lite.js"></script>');

    $(window).on('keypress', function(event) {
      if (event.which === TS.KeyCodes.toggleConsole) {
        Firebug.chrome.toggle();
      }
    });
  }

  TS.Platform.exit = function() {
    window.NetCastBack();
  };

  TS.Platform.name = 'netcast';
  
  // TODO: Double focus fix
    
  // Handle mouseoff event
  window.onmouseoff = function() {
    $.trace.info('Cursor off!');
    $(document.body).removeClass('cursor-visible');
    $(document.body).addClass('cursor-hidden');
  };
  window.onmouseon = function() {
    $.trace.info('Cursor on!');
    $(document.body).removeClass('cursor-hidden');
    $(document.body).addClass('cursor-visible');
  };

  $.trace.info('Registered mouseon/off events.');

  try {
    // Set initial mouse state
    if (window.NetCastGetMouseOnOff) {
      if (window.NetCastGetMouseOnOff() === 'off') {
        $(document.body).addClass('cursor-hidden');
        $.trace.info('Initial mouse state set to hidden');
      } else {
        $(document.body).addClass('cursor-visible');
        $.trace.info('Initial mouse state set to visible');
      }
    } else {
      $.trace.error('Couldn\'t get initial mouse state.');
    }
  } catch (ex) {
      $.trace.error('Couldn\'t get initial mouse state: ' + ex);
  }
  
})();
