// ADNAREL

TS.Config = {
  ROOT: window.location.protocol+'//'+window.location.hostname+'/',
  DEBUG: true,
	CONSOLE: true,
  geolocation: true,
  location: 'GB', // default location, will be overridden
  lang: function(){
    if (TS.Config.geolocation) {
      switch (TS.Config.location) {
        case 'GB': return 'en';
        case 'US': return 'en';
        case 'ES': return 'es';
        case 'FR': return 'fr';
        case 'DE': return 'de';
        case 'IT': return 'it';
        default: return 'en';
      }
    } else {
      var hashVars = $.getHash();
      var langCode = hashVars.lang ? hashVars.lang : 'en';
      return langCode;
    }
  },
  history: [],
  edition: function() {
    if (TS.Config.geolocation) {
      switch (TS.Config.location) {
        case 'GB': return 'en-gb';
        case 'US': return 'en-us';
        case 'ES': return 'es';
        case 'FR': return 'fr';
        case 'DE': return 'de';
        case 'IT': return 'it';
        default: return 'en-gb';
      }
    } else {
      var hashVars = $.getHash();
      var edition = hashVars.edition ? hashVars.edition : 'en-gb';
      return edition;
    }
  },
  feedSource: function() {
    var hashVars = $.getHash();
    var feedSource = hashVars.feedSource ? hashVars.feedSource : 'goal';
    return feedSource;
  },
  selectors:{
    mainContentId: '#section-content',
    preloader: '#preloader'
  },
  controllerSuffix: '.main.js',
  templateSuffix: '.template.html',
  defaultModuleStyle: 'style.css',
  forceTemplateDownload: true,
  videoTimeOut: 15*1000,
  feedTimeOut: 20*1000,
  resultDetailOpen: false,
  Path: {
    Platforms: 'js/GoalApp/js/platforms/',
    Modules: 'js/GoalApp/js/modules/',
    Assets: 'assets/GoalApp/assets/',
    Style: 'css/GoalApp/css/',
    Images: 'i/GoalApp/'
  },
  NewsFeed: {
    preloadThumbnails: true
  },
  MatchesFeed: {
    preloadLogos: true
  },
  CompetitionsFeed: {
    defaults: {
      'en-gb': 8, // Premiere League
      'fr': 16,   // Ligue 1
      'it': 13,   // Serie A
      'de': 9,    // Bundesliga
      'es': 7     // Primera Division
    }
  },
};

TS.Config.VideoTracker = {
    debug: true,
    omnitureTracker: {
      debug: true,
      s_account: 'premiumtvsamsunggoalctv',
      language: TS.Config.lang(), // if geolocation is true, this will be overridden
      country: TS.Config.edition() // if geolocation is true, this will be overridden
    },
    player: {
      width: 1280,
      height: 720,
      player: 'GoalApp',
      type: 'html',
      embedded: false,
      autoplay: false
    }
  }

TS.Config.EPlayerFeed = {
  preloadDefaultChannel: true,
  preloadVideoThumbnails: 'large',
  get playerID() {
    var edition = TS.Config.edition();
    //default: English - UK
    var id = "1onxr5ynrlbqx138yc1no3zvlv";
    //english US
    if(edition == "en-us"){
      //TODO:change to US playerID if we get
     id = "2jw6th4atmnd19sfk6z405535";
    }
    //french
    else if(edition == "fr"){
      id = "33i67o0hmzij113rro1ji0a7i";
    }
    //german
    else if(edition == "de"){
      id = "1spvxzexn8no1n3e7qozdl3j4";
    }
    //italian
    else if(edition == "it"){
      id = "1299czf4r49xy1sp6fy283eyiu";
    }
    //spanish
    else if(edition == "es"){
      id = "1ffeqmezyjtq018r4vvv03m5tv";
    }
    console.log('PLAYERID:', id)
    return id;
  }
};