
/**
 * TreadStone platform detection
 *
 * This script fills TS.Platform with platform info,
 * and pulls the palatform specific script from platforms/
 * Must be loaded between include.js and init.js.
 */

(function() {
  TS.Platform = {
    suffix: null,
    version: null,
    engine: null,
    corsSupport: !!(window.XMLHttpRequest && 'withCredentials' in new XMLHttpRequest()),
    
    // placeholders for platform functions
    exit: function() { $.trace.warn('Not implemented on this platform.'); }
  };

  var p = TS.Platform;

  // check platform and version
  var matches;

  if (matches = navigator.userAgent.match(/LG NetCast\.TV-(\d+)/)) {
    // LG NetCast
    p.suffix = 'netcast';
    p.version = matches[1];
    p.engine = 'webkit';
  } else if (matches = navigator.userAgent.match(/SmartHub/)) {
	p.suffix = 'smart-hub';
    p.version = matches[1];
    p.engine = 'webkit';
  } else if (window.PhoneGap) {
    // phoneGap
    p.suffix = 'phonegap';
    p.version = $.browser.version;
    p.engine = 'webkit';
  } else {
    // Desktop
    p.suffix = 'desktop';
    if ($.browser.webkit) {
      p.engine = 'webkit';
    } else if ($.browser.mozilla) {
      p.engine = 'gecko';
    } else if ($.browser.opera) {
      p.engine = 'presto';
    } else if ($.browser.msie) {
      p.engine = 'trident';
    }
    p.version = $.browser.version;
  }

  // load platform js
  if (p.suffix) {
    document.write('<script src="' + TS.Config.Path.Platforms + 
                   p.suffix +  '.js"></script>');
  }
})();

// JS 1.8.x features
if (!Function.prototype.bind) {
  Function.prototype.bind = function (oThis) {
    if (typeof this !== "function") {
      // closest thing possible to the ECMAScript 5 internal IsCallable function
      throw new TypeError("Function.prototype.bind - what is trying to be bound is not callable");
    }
 
    var aArgs = Array.prototype.slice.call(arguments, 1), 
        fToBind = this, 
        fNOP = function () {},
        fBound = function () {
          return fToBind.apply(this instanceof fNOP && oThis
                                 ? this
                                 : oThis,
                               aArgs.concat(Array.prototype.slice.call(arguments)));
        };
 
    fNOP.prototype = this.prototype;
    fBound.prototype = new fNOP();
 
    return fBound;
  };
}

if ( !Array.prototype.forEach ) {
  Array.prototype.forEach = function(fn, scope) {
    for(var i = 0, len = this.length; i < len; ++i) {
      fn.call(scope || this, this[i], i, this);
    }
  }
}

if(window.onoutofmemory) {
  window.onoutofmemory = function(){
      $.trace.warn('!!! WARNING - LOW IN MEMORY !!!');
  }
}

