<?php
/** Demo feed for result dates
 *
 * GET parameters:
 * competitionID:int
 */

include('generateSessionData.php');

$callback = isset($_GET['callback']) ? $_GET['callback'] : null;
$competitionID = isset($_GET['competitionID']) ? (int) $_GET['competitionID'] : 0;

class ResultDate {
  public $date;
  public $count;

  function ResultDate($date, $count) {
    $this->date = $date;
    $this->count = $count;
  }
}
$response = [];

function toMidnight($timestamp) {
  return (int) date("U", strtotime(date("Y-m-d 00:00:00", $timestamp)));
}

$lastDate = 0;
$files = ['results.dat', 'fixtures.dat'];
foreach ($files as $file) {
  $file = fopen($file, 'r');
  while ($obj = json_decode(fgets($file))) {
    if ($obj->competitionID !== $competitionID) {
      continue;
    }
    if (toMidnight($obj->kickoff) !== $lastDate) {
      $response[] = ['date' => toMidnight($obj->kickoff), 'count' => 1];
      $lastDate = toMidnight($obj->kickoff);
    } else {
      $response[sizeof($response) - 1]['count']++;
    }
  }
}

if ($callback) {
  header('Content-type', 'text/javascript');
  echo "$callback(".json_encode($response).");";
} else {
  header('Content-type', 'application/json');
  echo json_encode($response);
}
?>
