<?php

/** Demo feed for news
 *
 * GET parameters:
 * channelID:number
 * lang:string
 * callback:string
 */

include('generateSessionData.php');

$callback = isset($_GET['callback']) ? $_GET['callback'] : null;
$channelID = isset($_GET['channelID']) ? (int) $_GET['channelID'] : 0;

class NewsItem {
  public $picture;
  public $thumbnail;
  public $title;
  public $lead;
  public $body;

  function NewsItem($picture, $thumbnail, $title, $lead, $body) {
    $this->picture = $picture;
    $this->thumbnail = $thumbnail;
    $this->title = $title;
    $this->lead = $lead;
    $this->body = $body;
  }
}

$response = [];

$file = fopen('news.dat', 'r');
while ($newsItem = json_decode(fgets($file))) {
  if ($newsItem->channelID === $channelID) {
    $response[] = new NewsItem(
      $newsItem->picture,
      $newsItem->thumbnail,
      $newsItem->title,
      $newsItem->lead,
      $newsItem->body
    );
  }
};

if ($callback) {
  header('Content-type: text/javascript');
  echo "$callback(".json_encode($response).");";
} else {
  header('Content-type: application/json');
  echo json_encode($response);
}
?>
