describe('News', function() {
  it('Match Preview', function() {
    matchPreview.pull();
    waitsFor(function() {
      excpect(matchPreview.data.title).not.toBe(undefined);
      excpect(matchPreview.data.body).not.toBe(undefined);
    }, 2000);
  });
  it('Match Report', function() {
    matchReport.pull();
    waitsFor(function() {
      excpect(matchReport.data.title).not.toBe(undefined);
      excpect(matchReport.data.body).not.toBe(undefined);
    }, 2000);
  });
});

describe('Results / Fixtures', function() {
  it('Results and Fixtures', function() {
    resultsAndFixtures.pull();
    waitsFor(function() {
      expect(resultsAndFixtures.data.fixtures).not.toBe(undefined);
      expect(resultsAndFixtures.data.fixtures.length).not.toBe(0);
    }, 2000);
  });
});

describe('Match Details', function() {
  it('Match Events, Team Lineups', function() {
    matchEvents.pull();
    waitsFor(function() {
      expect(matchEvents.MatchData).not.toBe(undefined);
      expect(matchEvents.Team).not.toBe(undefined);
    }, 2000);
  });
  
  // Team Lineups are also included in Match Events!
  it('Team Lineups (redundant)', function() {
    teamLineups.pull();
    waitsFor(function() {
      expect(teamLineups.data.length).toBe(2);
    }, 2000);
  });

  it('Live Commentary', function() {
    liveCommentary.pull();
    waitsFor(function() {
      expect(liveCommentary.data.notToBe(0));
    }, 2000);
  });
});

describe('Tables', function() {
  it('League Tables', function() {
    leagueTables.pull();
    waitsFor(function() {
      expect(leagueTables.data.length).notToBe(0);
    }, 2000);
  });
});
