/*global namespace:false, $:false, _:false, TS:false, View:false, loadCss:false, loadTemplate:false, console:false, Preloader:false*/
/*jshint camelcase:true, curly:true, eqeqeq:true, immed:true, indent:2, latedef:true, newcap:true, noarg:true, noempty:true, nonew:true, quotmark:single, undef:true, unused:true, strict:true, trailing:true */

(function () {
  'use strict';
  TS.Modules.home  = {
    moduleName  : 'home',
    config      : {},
    autoInit    : true,
    navigator   : null,
    focusGraph  : null,
    initDone    : true,
    requires    : ['latestVideos', 'latestNews', 'latestResults', 'video'],
    init : function () {
      this.navigator = new TS.Modules.navigationController.Navigator('home', this);

      loadCss(TS.Config.Path.Style + 'home.css');
      var view = new View(loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix), '#section-content');

      this.focusGraph = new TS.Modules.focusController.FocusGraph();
      this.subModules = ['latestVideos', 'latestNews', 'latestResults'];

      // catch all submodules ready event
      this.subModules.map(function (i) {
        $(TS.Modules[i]).on('ready', function () {
          this.subReady = 1;
          $(TS.Modules.home).trigger('subReady', this);
        });
      });


      var hide = function () {
        $('#section-content').html('');
        this.subModules.map(function (i) {
          if (TS.Modules[i].hide) {
            TS.Modules[i].hide();
          }
        });
      }.bind(this);

      var show = function () {
        $('#section-content').empty();
        $('#section-home').empty();
        view.display();

        // set all submodules to subReady=0
        this.subModules.map(function (i) {
          TS.Modules[i].subReady    = 0;
          TS.Modules[i].errorState  = false;
        });

        // to avoid display bugs we need run the show methods in a different loop
        this.subModules.map(function (i) {
          TS.Modules[i].show();
        });

      }.bind(this);

      // set focusgraph on ready
      $(this).on('ready', function () {
        this.focusGraph.setElement($('#section-content')).setMap({
          latestVideos  : {
            element     : TS.Modules.latestVideos.focusGraph,
            right       : 'latestNews'
          },
          latestNews    : {
            left        : 'latestVideos',
            element     : TS.Modules.latestNews.focusGraph,
            right       : 'latestResults'
          },
          latestResults : {
            left        : 'latestNews',
            element     : TS.Modules.latestResults.focusGraph
          },
          initial       : 'latestNews'
        });

        TS.Modules.focusController.root.changeElement('content', this.focusGraph);
        TS.Modules.focusController.root.blur();
        this.focusGraph.setFocused();
        $('#section-home').show();

        if (TS.Modules.latestVideos.errorState || TS.Modules.latestNews.errorState || TS.Modules.latestResults.errorState) {
          Preloader.hide();
          TS.Modules.noticeWindow.alert({
            title     : $.translate('error_pageError'),
            text      : $.translate('error_pageContents'),
            yesButton : {
              buttonLabel : $.translate('label_Ok'),
              callback    : false
            }
          });
        }
      });

      $(this).on('subReady', function () {
        // trigger ready only if all the modules loaded
        if (TS.Modules.latestVideos.subReady && TS.Modules.latestNews.subReady && TS.Modules.latestResults.subReady) {
          $(this).trigger('ready');
        }
      });

      $(this.navigator).on('open', show);
      $(this.navigator).on('close', hide);
    }
  };
})();