describe('Initial states: ', function() {
  it('about page is open', function() {
    expect(TEST_ABOUT_IS_OPEN).toBe(true);
  });

  it('home button is active', function() {
    expect($('#menu [data-navigate="/"]')).toBe('.active');
  });
});

describe('Click on links: ', function() {
  it('click on pages (default)', function() {
    $('[data-navigate="/pages"]').trigger('click');
    expect(TEST_PAGES_HELLOWORLD_IS_OPEN).toBe(true);
    expect($('#menu [data-navigate="/pages"]')).toBe('.active');
  });

  it('click on loremipsum', function() {
    $('[data-navigate="/pages/loremipsum"]').trigger('click');
    expect(TEST_PAGES_LOREMIPSUM_IS_OPEN).toBe(true);
    expect($('#menu [data-navigate="/pages/loremipsum"]')).toBe('.active');
  });

  it('click on haha', function() {
    $('[data-navigate="/pages/helloworld/haha"]').trigger('click');
    expect(TEST_PAGES_HELLOWORLD_HAHA_IS_OPEN).toBe(true);
    expect($('#menu [data-navigate="/pages/helloworld/haha"]')).toBe('.active');
  });

  it('click on helloworld', function() {
    $('[data-navigate="/pages/helloworld"]').trigger('click');
    expect(TEST_PAGES_HELLOWORLD_IS_OPEN).toBe(true);
    expect($('#menu [data-navigate="/pages/helloworld"]')).toBe('.active');
  });

  it('click on about (with hash params)', function() {
    $('[data-navigate="/about#color=red"]').trigger('click');
    expect(TEST_ABOUT_IS_OPEN).toBe(true);
    expect($('#content')).toBe('.red');
  });

  it('click on home again', function() {
    $('[data-navigate="/"]').trigger('click');
    expect(TEST_ABOUT_IS_OPEN).toBe(true);
    expect($('#content')).not.toBe('.red');
  });
});

