/*global namespace:false, $:false, _:false, TS:false, View:false, loadCss:false, loadTemplate:false, console:false*/
/*jshint camelcase:true, curly:true, eqeqeq:true, immed:true, indent:2, latedef:true, newcap:true, noarg:true, noempty:true, nonew:true, quotmark:single, undef:true, unused:true, strict:true, trailing:true */

(function () {
  'use strict';
  TS.Modules.tables = {
    moduleName  : 'tables',
    autoInit    : true,
    config      : {},
    focusGraph  : null,
    requires    : ['goalFeeds'],
    navigator   : null,
    init        : function () {
      loadCss(TS.Config.Path.Style + 'tables.css');

      this.navigator    = new TS.Modules.navigationController.Navigator('tables', this);
      this.focusGraph   = new TS.Modules.focusController.FocusGraph();
      this.feedHandler  = TS.Modules.goalFeeds.tablesFeed;

      var view    = new View(loadTemplate(TS.Config.Path.Modules + this.moduleName + '/' + this.moduleName + TS.Config.templateSuffix), '#section-lmc-content');
      var viewRef = 0;
      var map;

      $('#section-lmc-content').empty();

      var show = function () {
        TS.Modules.livematchcentre.isLMC = false;

        // init textfields
        // header textfields
        view.set('table_team_name_label', $.translate('table_team_name_label'));
        view.set('table_p_label', $.translate('table_p_label'));
        view.set('table_w_label', $.translate('table_w_label'));
        view.set('table_d_label', $.translate('table_d_label'));
        view.set('table_L_label', $.translate('table_L_label'));
        view.set('table_gd_label', $.translate('table_gd_label'));
        view.set('table_pts_label', $.translate('table_pts_label'));

        viewRef = view.display();
        map     = {
          initial : 'down',
          up      : {
            element : viewRef.find('.buttons .sprite-lmc-tables-scrollup'),
            down    : 'down'
          },
          down : {
            element : viewRef.find('.buttons .sprite-lmc-tables-scrolldown'),
            up      : null
          }
        };

        this.focusGraph.setElement(viewRef).setMap(map);
        TS.Modules.livematchcentre.focusGraph.changeElement('content', this.focusGraph);

        this.feedHandler.pull({ competitionID : TS.Modules.livematchcentre.competitionID });
      }.bind(this);

      var feedReady = function (e, response) {
        var items           = [];
        var tablesContainer = $('#livematchcentre-tables');
        var downArrow       = tablesContainer.find('.down');
        var upArrow         = tablesContainer.find('.up');

        var processRow = function (data, position) {
          var item = [];

          for (var i in data) {
            item.push({
              key   : i,
              value : data[i]
            });
          }

          item.push({
            key   : '_position',
            value : position
          });
          return item;
        };

        for (var i = 0; i < response.processedResponse.results.length; i++) {
          items.push(processRow(response.processedResponse.results[i], i + 1));
        }

        console.log('FEED READY', items, $('#LMCtableRows'));

        view.foreach(items, '#LMCtableRows');
        $(viewRef).show();

        viewRef.find('.buttons .sprite-lmc-tables-scrollup').override('click', 'scroll', function () {
          $('#LMC_table')[0].scrollTop -= 50;
        });
        viewRef.find('.buttons .sprite-lmc-tables-scrolldown').override('click', 'scroll', function () {
          $('#LMC_table')[0].scrollTop += 50;
        });

        // mousewheel handling
        $('#LMC_table').override('mousewheel wheel', 'scroll', function (e) {
          $('#LMC_table')[0].scrollTop -= e.originalEvent.wheelDeltaY > 0 ? 50 : -50;
        });

        // up/down arrows disabled/enabled settings

        upArrow.addClass('disabled');

        $('#LMC_table').scroll(function () {
          //up
          if ($('#LMC_table')[0].scrollTop === 0) {
            upArrow.addClass('disabled');
            map.down.up = null;
            map.initial = 'down';
          } else {
            upArrow.removeClass('disabled');
            map.down.up = 'up';
            map.initial = 'up';
          }

          //down
          var max = $('#LMC_table')[0].scrollHeight - $('#LMC_table').height();
          if ($('#LMC_table')[0].scrollTop >= max) {
            downArrow.addClass('disabled');
            map.up.down = null;
            map.initial = 'up';
          } else {
            downArrow.removeClass('disabled');
            map.up.down = 'down';
            map.initial = 'down';
          }
        });

        $(this).trigger('ready');
      }.bind(this);

      $(this.feedHandler).on('ready change', feedReady);
      $(this.feedHandler).override('error', 'tablesErrorHandler', function () {
        $(this).trigger('error');
      }.bind(this));

      var hide = function () {
        $('#section-lmc-content').empty();
        $(this.feedHandler).override('error', 'tablesErrorHandler');
      };

      $(this.navigator).on('open', show);
      $(this.navigator).on('close', hide);
    }
  };
})();