/**********************************************************
 *                                                        *
 *                    .-''-.                              *
 *                  .`   ::.'.                            *
 *                 /  .:((((\\\                           *
 *               .' //((`  )))))                          *
 *              (  (/)':.__  _/                           *
 *             /   /c(   -=\</^                           *
 *            /   (/j)\  __.>)                            *
 *           (/  :(r :.'.\_./   Let's play some video!    *
 *           /  .'/    `(`-'                              *
 *          (   '( '``'  '.                               *
 *          /    ))    '   `-.                            *
 *         (  (  ( .    .     `-O                         *
 *         (( ( (: \    |       )                         *
 *          )|)) )\Y     \  `--<                          *
 *           |  `( \\    |   /                            *
 *           |    `||    :.  |                            *
 *           `-._  | \     `-|.                           *
 *               `-/ :\_.      ``\                        *
 *                /    `'----..../                        *
 *               /  , .        |/                         *
 *              /               \                         *
 *             /                 \                        *
 *            J    .             |                        *
 *            |    |             /                        *
 *            |  _ _\__         /                         *
 *            \      _\).       |                         *
 *            |       ||        |                         *
 **********************************************************/

TS.Modules.video = {
	moduleName : 'video',
	autoInit : false,
	config : {},
	focusGraph : null,
	navigator : null,
	adManager : null,
	hideControlsTimeOut : 6000,
	timeUpdateInterval : 500,
	loadVideoDelay : 200,
	leapTime : 10,

	calcTime : function(secs) {
		var minutes = Math.floor(secs / 60);
		var seconds = Math.floor(secs - minutes * 60);
		var hours = Math.floor(time / 3600);
		var hour = secs - hours * 3600;

		if (hour > 0) {
			if (hour < 10) {
				hour = '0' + hour;
			}
		} else {
			hour = '00';
		}
		if (minutes < 10) {
			minutes = '0' + minutes;
		}
		if (seconds < 10) {
			seconds = '0' + seconds;
		}
		var time = hour + ':' + minutes + ':' + seconds;
		return time;
	},
	
	handleError: function() {
	  this.timeoutHandler();
	},
	
	timeoutHandler: function() {
	  
    $('body').off('keydown', TS.Modules.video.showControls);

    // don't show an error dialog on ad, just skip it
    if (this.liverailPlaying !== false)
      return false;
    
    TS.Modules.noticeWindow.alert({
      title : $.translate('label_error'),
      text : $.translate('stream_content_video_error'),
      yesButton : {
        buttonLabel : $.translate('label_return'),
        callback : function() {
          try {
            clearTimeout(TS.Modules.video.updateInterval);
          } catch (z) {
          }
          ;
          try {
            clearTimeout(TS.Modules.video.hideControls);
          } catch (z) {
          }
          ;
          try {
            $('#videoplayer').remove();
          } catch (z) {
          }
          ;
          try {
            $('#videoObject').remove();
          } catch (z) {
          }
          ;
          try {
            $('#videoControls').remove();
          } catch (z) {
          }
          ;
          try {
            $('#videoheader').remove();
          } catch (z) {
          }
          ;
        }
      },
      noButton : {
        buttonLabel : $.translate('label_wait'),
        callback : function() {
          $('body').on('keydown', TS.Modules.video.showControls);
          timer = setTimeout(TS.Modules.video.timeoutHandler, TS.Config.videoTimeOut);
        }
      }
    });
  },

	init : function() {
		/*
		console.log('INIT CURRENT VIDEO-----------------------------------');
		console.log(TS.currentVideo);
		console.log('++++++++++++++++++++++++++++++++++++++++');
		 */
		// RESET PLAYER IF PRESENT
		try {
			clearTimeout(TS.Modules.video.updateInterval);
		} catch (z) {
		}
		;
		try {
			clearTimeout(TS.Modules.video.hideControls);
		} catch (z) {
		}
		;
		try {
			$('#videoplayer').remove();
		} catch (z) {
		}
		;
		try {
			$('#videoObject').remove();
		} catch (z) {
		}
		;
		try {
			$('#videoControls').remove();
		} catch (z) {
		}
		;
		try {
			$('#videoheader').remove();
		} catch (z) {
		}
		;

		/**
		 * Inits the ad manager.
		 */

		/**
		 * Handles the navigator open event.
		 */
		var handleNavigatorOpen = function(event, data) {

		};

		/**
		 * Handles the navigator close event.
		 */
		var handleNavigatorClose = function(event, data) {

		}
		var vId = TS.currentVideo.id;

		$.trace.log(vId);

		var url = TS.currentVideo.streamUrl;

		// level3
		url = url.replace('rtmp://vod.l3.cms.performgroup.com/perform-vod-l3/',
				'http://vod.cms.download.performgroup.com/');

		// Akamai
		url = url.replace('rtmp://vod.cms.performgroup.com/fod/flv/',
				'http://vod.cms.download.performgroup.com/');

		// Amazon cloud
		url = url.replace('rtmp://fod.aka.oss1.performgroup.com/fod/oss1/',
				'http://vod.aka.oss1.performgroup.com/');

		//this.adManager.loadPreroll(url);

		loadCss(TS.Config.Path.Style + 'video.css');

		var view = new View(loadTemplate(TS.Config.Path.Modules
				+ this.moduleName + '/' + this.moduleName
				+ TS.Config.templateSuffix), '#app-wrapper');
		view.set('q_menu_label', $.translate('q_menu_label'));
		view.set('video_hide_controls_label', $
				.translate('video_hide_controls_label'));
		view.set('video_back_label', $.translate('video_back_label'));
		view.set('video_info_button_label', $
				.translate('video_info_button_label'));
		view.display();

		// var qmenuButton = $('#qmenu a');
		var hideButton = $('#hidecontrols a');
		var backButton = $('#back a');

		var previousButton = $('#btn-prevVideo');
		var rewindButton = $('#btn-rewind');
		var playButton = $('#btn-play');
		var forwardButton = $('#btn-forward');
		var nextButton = $('#btn-nextVideo');
		var infoButton = $('#information');

		//$('#videoObject').attr('src', url);
		$('#videoObject').attr('autoplay', 'autoplay');
		// $('#videoObject').css('width', '1280px');
		// $('#videoObject').css('height', '720px');
		if (TS.Config.DEBUG) {
			var temp = url.split('.');
			var type = temp[temp.length - 1];
			var loadStartTime = 0;
			var loadEndTime = 0;
			$.trace.warn('STREAM Type: ' + type);

			$('#videoObject').on('loadstart', function() {
				loadStartTime = microtime(true);
			})
			$('#videoObject').on('canplay', function() {
				loadEndTime = microtime(true);
				$.trace.info('loadTime is: ' + (loadEndTime - loadStartTime));
			})

		}

		//playButton.addClass('playing');
		//$('#videoObject').play();

		$('#videoplayer').css('display', 'block');

		//alert(vId);
		// init textfields
		// header textfields

		// HIDE CONTROLS
		this.initHideControls = function() {
			clearTimeout(TS.Modules.video.hideControls);
			TS.Modules.video.hideControls = setTimeout(function() {
				TS.Modules.video.toggleControls(false);
			}, TS.Modules.video.hideControlsTimeOut);
		};

		this.toggleControls = function(state) {
			if (state !== true && $('#videoControls').css('display') == 'block'
					&& $('#videoheader').css('display') == 'block') {
				$('#videoControls').css('display', 'none');
				$('#videoheader').css('display', 'none');
				$('span.info-button-label').html(
						$.translate('video_info_button_label'));
				$('#video-info').css('display', 'none');
			} else if (state !== false && !this.liverailPlaying) {
				$('#videoControls').css('display', 'block');
				$('#videoheader').css('display', 'block');
				TS.Modules.video.initHideControls();
				this.focusGraph.setFocused();
			}
		}.bind(this);

		/**
		 * Inits the focusgraph and sets it's map, for
		 * keyboard navigation. After this sets the focus
		 * on the inital item, which is the play button.
		 */
		var initFocusGraph = function() {

			// create the basic focusgraph for the videoview instance
			this.focusGraph = new TS.Modules.focusController.FocusGraph();
			this.focusGraph.setElement($('#videoplayer'));

			// create a focusgraph for the header buttons
			var headerGraph = new TS.Modules.focusController.FocusGraph();
			headerGraph.setElement($('#videoheader'));

			// create a focusgraph for the control buttons.
			// the buttons on the top are the real controllers because the bottom button
			// is just an information button...so keep it in mind! ;)
			var controlsGraph = new TS.Modules.focusController.FocusGraph();
			controlsGraph.setElement($('.controls'));

			// create a basic focusgraph's map
			this.focusGraph.setMap({
				'header' : {
					element : headerGraph,
					down : 'controls'
				},
				'controls' : {
					element : controlsGraph,
					up : 'header',
					down : 'info'
				},
				'info' : {
					element : infoButton,
					up : 'controls'
				},
				initial : 'controls'
			});

			// create the headerGraph's map
			headerGraph.setMap({
				/*
				'qmenu' : {
				  element:  qmenuButton,
				  right: 'hide'
				},
				 */
				'hide' : {
					element : hideButton,
					left : 'hide',
					right : 'back'
				},
				'back' : {
					element : backButton,
					left : 'hide'
				},
				initial : 'hide'
			});

			// create the controlsGraph's map
			controlsGraph.setMap({
				'previous' : {
					element : previousButton,
					right : 'rewind'
				},
				'rewind' : {
					element : rewindButton,
					left : 'previous',
					right : 'play'
				},
				'play' : {
					element : playButton,
					left : 'rewind',
					right : 'forward'
				},
				'forward' : {
					element : forwardButton,
					left : 'play',
					right : 'next'
				},
				'next' : {
					element : nextButton,
					left : 'forward'
				},
				initial : 'play'
			});

			// sets the focus on the current item
			this.focusGraph.setFocused();
		}.bind(this);

		initFocusGraph();
		this.showControls = function() {
			if ($('#video-preloader').is(':visible')) {
				event.stopPropagation();
				return;
			}
			TS.Modules.video.toggleControls(true);
		}
		$('body').on('keydown', this.showControls);

		$('#videoplayer, #videoplayer .controls a').keydown(function(e) {
			if (e.which == TS.KeyCodes.back) {
				TS.Modules.video.hide();
				e.stopPropagation();
			}
			if ($('#videoControls:visible').length)
				return true;

			TS.Modules.video.toggleControls(true);
			return false;
		});
		$('#videoplayer .controls a').focus(function() {
			TS.Modules.video.initHideControls();
		});
		//initNavigator();

		/**
		 * Inits the navigator and sets the listener for
		 * the open and close events.
		 */
		var initNavigator = function() {
			this.navigator = new TS.Modules.navigationController.Navigator(
					this.moduleName);

			// Sets the event handler methods
			$(this.navigator).on('open', handleNavigatorOpen);
			$(this.navigator).on('close', handleNavigatorClose);

		};

		$('#video-info img').attr('src', TS.currentVideo.thumbNail);
		$('#video-info div.info-content span.info-title').html(
				TS.currentVideo.title);
		$('#video-info div.info-content p').html(TS.currentVideo.descr);
		$('#video-info span.info-duration').html(
				$.translate('video_info_duration') + ': '
						+ this.calcTime(TS.currentVideo.streamDuration));

		// CREATE TIME AND CURRENTTIME INFO
		var currentTime = 0;
		var newPosition = 0;
		var updateTime = function() {
			if (!$('#videoObject').length)
				return false;

			currentTime = $('#videoObject')[0].currentTime;
			$('#video-currentTime').html(this.calcTime(currentTime));
			var qwe = TS.currentVideo.streamDuration / currentTime;
			newPosition = 110 + (144 / qwe);
			$('#video-slider').css('left', newPosition);

			$('#videoControls .playedbackground').width(
					parseInt(144 / qwe) + 10);

			/*if($('#videoObject')[0].paused && $('#btn-pause:visible').length){
				//pauseButton.trigger('click');
				}
			else if(!$('#videoObject')[0].paused && $('#btn-play:visible').length){
				playButton.trigger('click');
				}*/
			TS.Modules.video.updateInterval = setTimeout(updateTime,
					TS.Modules.video.timeUpdateInterval);
		}.bind(this);

		// hide function
		this.hide = function() {
			clearTimeout(TS.Modules.video.updateInterval);
			clearTimeout(TS.Modules.video.hideControls);

			// console.log('REMOVE VIDEO OBJECT REMOVE DEBUG');
			// TS.Modules.LiveRail.adManager.stopAd();
			// console.log($('#videoObject'));

			try {
				var x = $(document).find('iframe');
				$(x).find('script').remove();
			} catch (err) {
				$.trace.error(err);
			}
			$('body').off('keydown', TS.Modules.video.showControls);

			//$('#videoObject').pause();
			delete ($('#videoObject'));
			$('#videoObject').remove();

			// console.log('Video removed');
			$('#videoplayer').remove();
			$('#videoObject').remove();
			$('#videoControls').remove();
			$('#videoheader').remove();
			TS.Modules.LiveRail.clear();

			$(TS.Modules.video).trigger('close');
			TS.Modules.focusController.root.setFocused();
		};

		$('#video-totalTime').html('');
		$('#video-totalTime').html(
				this.calcTime(TS.currentVideo.streamDuration));
		clearTimeout(TS.Modules.video.updateInterval);
		TS.Modules.video.updateInterval = setTimeout(updateTime,
				TS.Modules.video.timeUpdateInterval);

		/* PLAY & PAUSE VIDEO */
		var playVideo = function(isRemote) {

			// Check system Mute
			var AudioMute = false;
			if (window.samsung.audio.GetSystemMute() === 1
					|| window.samsung.audio.GetSystemMute() === true
					|| window.samsung.audio.GetUserMute() === 1
					|| window.samsung.audio.GetUserMute() === true) {
				AudioMute = true;
			}

			if ($('#videoObject')[0].paused) {
				$('#videoObject')[0].play();

				TS.Modules.video.initHideControls();
				playButton[0].firstElementChild.className = 'icon sprite-videoplayer-pauseicon';
			} else if (!isRemote || isRemote == false) {
				$('#videoObject')[0].pause();
				playButton[0].firstElementChild.className = 'icon sprite-videoplayer-playicon';
			}

			if (AudioMute) {
				window.samsung.audio.SetUserMute(true);
				window.samsung.audio.SetUserMute(1);
				window.samsung.audio.SetSystemMute(true);
				window.samsung.audio.SetSystemMute(1);
			} else {
				window.samsung.audio.SetUserMute(false);
				window.samsung.audio.SetUserMute(0);
				window.samsung.audio.SetSystemMute(false);
				window.samsung.audio.SetSystemMute(0);
			}

		};
		var playVideoRemote = function(event) {
			if (event.which == TS.KeyCodes.play) {
				playVideo(true);
			}
		}

		$(document.body).keydown(playVideoRemote);

		var pauseVideo = function(isRemote) {
			if ($('#videoObject')[0].paused && (!isRemote || isRemote == false)) {
				$('#videoObject')[0].play();
				TS.Modules.video.initHideControls();
				playButton[0].firstElementChild.className = 'icon sprite-videoplayer-pauseicon';
			} else {
				$('#videoObject')[0].pause();
				playButton[0].firstElementChild.className = 'icon sprite-videoplayer-playicon';
			}
		};
		var pauseVideoRemote = function(event) {
			if (event.which == TS.KeyCodes.pause) {
				pauseVideo(true);
			}
		}

		$(document.body).keydown(pauseVideoRemote);

		// REGISTER CONTROL BUTTON EVENTS
		playButton.unbind('click');
		playButton.bind('click', function() {
			// don't react while preloader is visible
			if ($('#video-preloader').is(':visible')) {
				event.stopPropagation();
				return;
			}
			playVideo();
		});

		// REGISTER BUTTON EVENTS

		/* HIDE VIDEO FOR BACK BUTTON AND STOP BUTTON ON REMOTE */
		var hideVideo = function() {
			TS.Modules.video.hide();
		};

		var hideVideoRemote = function(event) {
			if (event.which == TS.KeyCodes.stop) {
				hideVideo();
			}
		}

		$(document.body).keydown(hideVideoRemote);

		backButton.unbind('click');
		backButton.bind('click', function() {
			hideVideo();
		});

		/* LG QMENU 
		qmenuButton.unbind('click');
		qmenuButton.bind('click', function(){
		  window.NetCastLaunchQMENU();
		  return false;
		});
		 */

		/* SHOW INFO */
		var showInfo = function() {
			if ($('#video-info').css('display') == 'none') {
				$(this).find('span.info-button-label').html(
						$.translate('video_info_button_hide_label'));
				$('#video-info').css('display', 'block');
			} else {
				$(this).find('span.info-button-label').html(
						$.translate('video_info_button_label'));
				$('#video-info').css('display', 'none');
			}
			TS.Modules.video.initHideControls();
		};

		var showInfoRemote = function(event) {
			if (event.which == TS.KeyCodes.info) {
				showInfo();
			}
		}

		$(document.body).keydown(showInfoRemote);

		infoButton.unbind('click');
		infoButton.bind('click', function() {
			showInfo();
		});

		/* REWIND VIDEO */
		var rewVideo = function() {
			var duration = TS.currentVideo.streamDuration;
			var current = $('#videoObject')[0].currentTime;
			if (current < TS.Modules.video.leapTime) {
				$('#videoObject')[0].currentTime = 0;
			} else {
				$('#videoObject')[0].currentTime = $('#videoObject')[0].currentTime
						- TS.Modules.video.leapTime;
			}
			if (!$('#videoObject')[0].paused) {
				TS.Modules.video.initHideControls();
			}
			updateTime();
		};

		var rewVideoRemote = function(event) {
			if (event.which == TS.KeyCodes.rewind) {
				rewVideo();
			}
		}

		$(document.body).keydown(rewVideoRemote);

		rewindButton.unbind('click');
		rewindButton.bind('click', function() {
			rewVideo();
		});

		/* FORWARD VIDEO */

		var forwardVideo = function() {
			var duration = TS.currentVideo.streamDuration;
			var current = $('#videoObject')[0].currentTime;
			if ((duration - current) < TS.Modules.video.leapTime) {
				return false;
			} else {
				$('#videoObject')[0].currentTime = $('#videoObject')[0].currentTime
						+ TS.Modules.video.leapTime;
			}
			if (!$('#videoObject')[0].paused) {
				TS.Modules.video.initHideControls();
			}
			updateTime();
		};

		var forwardVideoRemote = function(event) {
			if (event.which == TS.KeyCodes.forward) {
				forwardVideo();
			}
		}

		$(document.body).keydown(forwardVideoRemote);

		forwardButton.unbind('click');
		forwardButton.bind('click', function() {
			forwardVideo();
		});

		var storeVideoData = function(obj) {
			var newVideo = obj;
			TS.currentVideo.arrayIndex = newVideo.arrayIndex;
			TS.currentVideo.descr = newVideo.descr;
			TS.currentVideo.title = newVideo.title;
			TS.currentVideo.streamUrl = newVideo.streamUrl;
			TS.currentVideo.streamDuration = newVideo.streamDuration;
			TS.currentVideo.id = newVideo.id;
			return true;
		}

		nextButton.unbind('click');
		nextButton.bind('click', function() {
			if (TS.Modules.video.isNext()) {
				TS.Modules.video.liverail('preroll', 'next');
				TS.Modules.video.Preloader('show');
			}
		});

		previousButton.unbind('click');
		previousButton.bind('click', function() {
			if (TS.Modules.video.isPrevious()) {
				TS.Modules.video.liverail('preroll', 'previous');
				TS.Modules.video.Preloader('show');
			}
		});

		hideButton.unbind('click');
		hideButton.bind('click', this.toggleControls);

		// seek
		$('#videoControls .seekbackground,#videoControls .playedbackground')
				.click(
						function(event) {
							var clientRect = $('#videoControls .seekbackground')[0]
									.getBoundingClientRect(), videoPos = (event.clientX - clientRect.left)
									* $('#videoObject')[0].duration
									/ clientRect.width;
							$('#videoObject')[0].currentTime = videoPos;
							TS.Modules.video.initHideControls();
						});

		$('#videoControls .seekbackground,#videoControls .playedbackground')
				.mousemove(
						function(event) {
							if (!$('#videoObject')[0].duration
									|| isNaN($('#videoObject')[0].duration))
								return false;
							var clientRect = $('#videoControls .seekbackground')[0]
									.getBoundingClientRect(), videoPos = (event.clientX - clientRect.left)
									* $('#videoObject')[0].duration
									/ clientRect.width, minutes = parseInt(videoPos / 60), seconds = parseInt(videoPos % 60);
							this.title = (minutes > 9 ? minutes : '0' + minutes)
									+ ':'
									+ (seconds > 9 ? seconds : '0' + seconds);
						});
		$('#videoObject').on('loadstart', function() {
			TS.Modules.video.Preloader('show');
		})
		$('#videoObject').on('ended', function() {
			TS.Modules.video.Preloader('show');
		})
		$('#videoObject').on('canplay', function() {
			TS.Modules.video.Preloader('hide');
		})
		$('#videoObject').on('play', function() {
			TS.Modules.video.Preloader('hide');
			TS.Modules.video.toggleControls(true);
		})
		// FIX VIDEO SIZE TO FIT TO SCREEN
		$('#videoObject').css('height', 720);
		// this.toggleControls(true);
		this.liverail('preroll');

		TS.Modules.focusController.root.blur();
		document.body.focus();
	},

	Preloader : function(state) {
		if (state === 'hide') {
			$('#video-preloader').css('display', 'none');
			TS.Modules.video.toggleControls(true);
		}
		if (state === 'show') {
			$('#video-preloader').css('display', 'block');
			TS.Modules.video.toggleControls(false);
		}
	},

	convertUrl : function(url) {
		return url.replace(
				'rtmp://vod.l3.cms.performgroup.com/perform-vod-l3/',
				'http://vod.cms.download.performgroup.com/')
		// Akamai
		.replace('rtmp://vod.cms.performgroup.com/fod/flv/',
				'http://vod.cms.download.performgroup.com/')
		// Amazon cloud
		.replace('rtmp://fod.aka.oss1.performgroup.com/fod/oss1/',
				'http://vod.aka.oss1.performgroup.com/');
	},

	playUrl : function(url) {
		var timer;
		var timeoutHandler = function() {
		  TS.Modules.video.timeoutHandler();
		}
		timer = setTimeout(timeoutHandler, TS.Config.videoTimeOut);

		$('#video').html($('#video').html());
		$('#videoObject').on('click', this.toggleControls);
		$('#videoObject').on('canplay', function() {
			clearTimeout(timer);
			$('#ddlShadow').hide();
			$('#alertDiv').remove();
		});
		$('#videoObject').on('play', function() {
			TS.Modules.video.focusGraph.setFocused();
		});
		$('#videoObject').on('ended', function() {
			$('#videoObject').on('loadstart', function() {
				TS.Modules.video.Preloader('show');
			})
			$('#videoObject').on('ended', function() {
				TS.Modules.video.Preloader('show');
			})
			$('#videoObject').on('canplay', function() {
				TS.Modules.video.Preloader('hide');
			})
			$('#videoObject').on('play', function() {
				TS.Modules.video.Preloader('hide');
			})
			// FIX VIDEO SIZE TO FIT TO SCREEN
			$('#videoObject').css('height', 720);

			TS.Modules.video.liverail('postroll');
		});

		// start tracking of video
		videoTracker
				&& videoTracker.providers.html5.trackVideo($('#videoObject'),
						TS.currentVideo.streamUrl, TS.currentVideo.title,
						TS.currentVideo.descr, TS.currentVideo.id, null, /* not ad */
						TS.currentVideo.streamDuration);

		$('#videoObject').attr('src', this.convertUrl(url));
		$('#video-slider').css('left', 0);
		// this.toggleControls(true);
		// this.initHideControls();
	},

	play : function(video) {
		/*
		console.log('VIDEO-----------------------------------');
		console.log(video);
		console.log('++++++++++++++++++++++++++++++++++++++++');
		console.log('CURRENT VIDEO-----------------------------------');
		console.log(TS.currentVideo);
		console.log('++++++++++++++++++++++++++++++++++++++++');
		 */
		TS.currentVideo = video || TS.currentVideo;
		// console.log($('#videoObject').length);
		// console.log(TS.currentVideo);
		// console.log( this );
		// console.log( '****************************************************************************************************' );
		// console.log( "caller is " + arguments.callee.caller.toString() );
		// console.log( '8888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888888' );
		if ($('#videoObject').length) {
			$('#btn-nextVideo').css('opacity', '1');
			$('#btn-prevVideo').css('opacity', '1');
			if (TS.Modules.video.isNext() == false) {
				$('#btn-nextVideo').css('opacity', '0.3');
			}
			if (TS.Modules.video.isPrevious() == false) {
				$('#btn-prevVideo').css('opacity', '0.3');
			}

			this.toggleControls(true);
			this.liverailPlaying = false;
			this.playUrl(TS.currentVideo.streamUrl);
			$('#btn-play')[0].firstElementChild.className = 'icon sprite-videoplayer-pauseicon';
			$('#video-info img').attr('src', TS.currentVideo.thumbNail);
			$('#video-info div.info-content span.info-title').html(
					TS.currentVideo.title);
			$('#video-info div.info-content p').html(TS.currentVideo.descr);
			$('#video-info span.info-duration').html(
					$.translate('video_info_duration') + ': '
							+ this.calcTime(TS.currentVideo.streamDuration));
			$('#video-totalTime').html(
					this.calcTime(TS.currentVideo.streamDuration));

			// pageing buttons
			TS.Modules.video.isPrevious()
					&& $('#btn-prevVideo').removeClass('disabled')
					|| $('#btn-prevVideo').addClass('disabled');
			TS.Modules.video.isNext()
					&& $('#btn-nextVideo').removeClass('disabled')
					|| $('#btn-nextVideo').addClass('disabled');

			$('#videoObject').on('loadstart', function() {
				TS.Modules.video.Preloader('show');
			})
			$('#videoObject').on('ended', function() {
				TS.Modules.video.Preloader('show');
			})
			$('#videoObject').on('canplay', function() {
				TS.Modules.video.Preloader('hide');
			})
			$('#videoObject').on('play', function() {
				TS.Modules.video.Preloader('hide');
			})
			// HIDE PRELOADER FAILSAFE
			setTimeout("TS.Modules.video.Preloader('hide')", 4000);

			// FIX VIDEO SIZE TO FIT TO SCREEN
			$('#videoObject').css('height', 720);
		} else
			this.init();
	},

	liverail : function(_roll, trigger) {
		$('#videoObject')[0].pause();
		TS.Modules.video.Preloader('show');
		TS.Modules.LiveRail.initLiveRail();
		this.toggleControls(false);
		this.liverailPlaying = _roll;

		// omniture tracking
		videoTracker
				&& videoTracker.providers.html5.trackVideo($('#videoObject'),
						undefined, _roll, 'LiveRail');

		if (_roll == 'preroll') {
			if (trigger) {
				// $('#videoObject').unbind('ended').bind('ended',function(){$(TS.Modules.video).trigger(trigger)});
				// console.log('-------------next', trigger);
			} else {
				// $('#videoObject').unbind('ended').bind('ended',function(){TS.Modules.video.play();});
			}
			TS.Modules.LiveRail.adManager.preroll(trigger);
		} else if (_roll == 'postroll') {
			// $('#videoObject').unbind('ended').bind('ended',function(){TS.Modules.video.hide();});
			TS.Modules.LiveRail.adManager.postroll();
		}
		if (TS.Config.DEBUG) {
			$('#videoObject')
					.on(
							'play',
							function() {
								setTimeout(
										"$('#videoObject')[0].currentTime = $('#videoObject')[0].duration - 5",
										500);
							});
		}
	},

	isNext : function() {
		return true
	},
	isPrevious : function() {
		return true
	}
};