/**
 * @author local.user
 */

TS.Modules.videoAds.LiveRailAdManager = function (){

		// UNUSED
    //this.prerollUrl = 'http://ad4.liverail.com/?LR_SCHEMA=jsonp&LR_JSONP_HANDLE=liverailJsonpResult&LR_FORMAT=video%2Fmp4&LR_ADMAP=in%3A%3A0&LR_PUBLISHER_ID=1331';
    //this.postrollUrl = 'http://ad4.liverail.com/?LR_SCHEMA=jsonp&LR_JSONP_HANDLE=liverailJsonpResult&LR_FORMAT=video%2Fmp4&LR_ADMAP=in%3A%3A0&LR_PUBLISHER_ID=1331';

    // ******************** jsonp loading
		
		
		/**
		 * Builds the liveRail url, using the entiry params.
		 * 
		 * @param params (Object)
		 * @param params.postRoll (Boolean) - if it's true it sends a postroll request. The default value is FALSE.
		 * @param params.partnerId (Number) - the liveRail partner id which identifies the partner.
		 * @param params.title (String) - the current video clip's title, before this content the player play the preroll ad.
		 * @param params.description (String) - the current video clip's description.
		 */
    function buildLiverailUrl(params) 
    {
        var adMap = "LR_ADMAP=in::0";

        if(params.postRoll)
            adMap = "LR_ADMAP=in::100%";

        var url = 'http://ad4.liverail.com/?LR_PUBLISHER_ID=2443&LR_SCHEMA=jsonp&' + adMap + '&LR_FORMAT=video%2Fmp4&LR_JSONP_HANDLE=?';

        url += '&LR_PARTNERS=' + params.partnerId;
        url += '&LR_TITLE=' + params.title;
        url += '&LR_DESCRIPTION=' + params.description;

        return url;
    }
		
		/*
    function getLiverailTags(params) {
        var tags = "";
        var configModel = params.configModel;
        var videoList = params.videoList;
        var channelModel = videoList.channel.data.category || {
            name: videoList.channel.title,
            genre: 'Sports'
        };
        var playlistModel = params.playlistModel;

        tags += "HTML5=" + "true,";
        tags += "autoPlay=" + configModel.autoPlay + ",";
        tags += "startMute=" + configModel.startMute + ",";
        tags += "playerType=" + configModel.playerType + ",";
        tags += "playerSize=" + configModel.videoWidth + ",";
        tags += "genre=" + channelModel.genre + ",";
        tags += "category=" + channelModel.name + ",";
        tags += "autoPlay=" + configModel.autoPlay + "XXX";
        tags += "startMute=" + configModel.startMute + "XXX";
        tags += "playerType=" + configModel.playerType + "XXX";
        tags += "playerSize=" + configModel.videoWidth + "XXX";
        tags += "genre=" + channelModel.genre + "XXX";
        tags += "category=" + channelModel.name + "XXX__EOT";

        return tags;
    }
		*/
		
		/**
		 * Loads the pre- or postroll ad.
		 * 
		 * @param params (Object)
		 * @param params.postRoll (Boolean) - if it's true it sends a postroll request. The default value is FALSE.
		 * @param params.partnerId (Number) - the liveRail partner id which identifies the partner.
		 * @param params.title (String) - the current video clip's title, before this content the player play the preroll ad.
		 * @param params.description (String) - the current video clip's description.
		 */
    this.load = function (params) {
	    var url = buildLiverailUrl(params);
      
      $.ajax({
      	url: url,
        type: "GET",
        cache: false,
        dataType:"jsonp",
        jsonp: 'LR_JSONP_HANDLE',
        error:onError.bind(this),
        success: onSuccess.bind(this)
      });
    };
		
		/**
		 * Handles the pre- or postroll JSONP ad loading error. This method triggers an 'LiveRail.Load.Error' event with the
		 * received detailed error data.
		 */
    function onError(data){
      //$.trace("Json error ");
			$(this).trigger('LiveRail.Load.Error',data);
    }
		
		/**
		 * Handles the pre- or postroll JSONP ad loading success. This method triggers an 'LiveRail.Load.Success' event with
		 * the received data.
		 */
    function onSuccess(data){
      //that.ad = data;
      //callback({valid:true, ad:data});
      this.ad = data;
    	$(this).trigger('LiveRail.Load.Success',data);
    }

    // ********************* tracking methods

    this.trackImpressions = function() {
        var i = 0, l = this.ad.impression.length;
        for (; i < l; i += 1) {
            this.track(this.ad.impression[i]);
        }
    };

    this.quartile = 0;

    this.trackProgress = function(currentTime, duration) {
        var i, l;
        if (typeof this.ad.trackingevents !== 'object') { return true; }
        //$.trace("trackProgress ");

        if (currentTime >= duration / 4.0 && currentTime < duration / 2.0 && this.quartile === 0) {
            this.quartile++;
            if (typeof this.ad.trackingevents.firstQuartile === 'object' && typeof this.ad.trackingevents.firstQuartile.length === 'number') {
                l = this.ad.trackingevents.firstQuartile.length;
                for (i = 0; i < l; i += 1) {
                    //$.trace("track firstQuartile");
                    this.track(this.ad.trackingevents.firstQuartile[i]);
                }
            }
        }
        if (currentTime >= duration / 2.0 && currentTime < 3.0 * duration / 4.0 && this.quartile === 1) {
            this.quartile++;
            if (typeof this.ad.trackingevents.midpoint === 'object' && typeof this.ad.trackingevents.midpoint.length === 'number') {
                l = this.ad.trackingevents.midpoint.length;
                for (i = 0; i < l; i++) {
                    //$.trace("track midpoint");
                    this.track(this.ad.trackingevents.midpoint[i]);
                }
            }
        }
        if (currentTime >= 3.0 * duration / 4.0 && currentTime < duration && this.quartile === 2) {
            this.quartile++;
            if (typeof this.ad.trackingevents.thirdQuartile === 'object' && typeof this.ad.trackingevents.thirdQuartile.length === 'number') {
                l = this.ad.trackingevents.thirdQuartile.length;
                for (i = 0; i < l; i += 1) {
                    //$.trace("track thirdQuartile");
                    this.track(this.ad.trackingevents.thirdQuartile[i]);
                }
            }
        }

    };

    this.trackEnd = function() {
        //$.trace("track end");

        var i, l;

        if (typeof this.ad.trackingevents.complete === 'object' && 
        		typeof this.ad.trackingevents.complete.length === 'number' && 
        		this.quartile === 3) 
        		{
            	this.quartile++;
            	l = this.ad.trackingevents.complete.length;
            	for (i = 0; i < l; i += 1) {
              	  this.track(this.ad.trackingevents.complete[i]);
            	}
        }
    };

    // todo
    this.trackPause = $.noop;
    this.trackResume = $.noop;

    this.track = function(url) {
        //$.trace("Liverail track " + url);

        var pixel = document.createElement('img');
        pixel.style.display = "none";
        pixel.width = 1;
        pixel.height = 1;
        pixel.src = url;
        document.body.appendChild(pixel);
    };

}
