// BALTHASAR-2

/** TRANSLATE 
 *
 *  
 */
$.translate = function(label){
  // var lang = TS.Config.lang();
  
  if(TS.Dictionary[label][TS.currentLang]==='' || TS.Dictionary[label][TS.currentLang]===undefined){
    return(TS.Dictionary[label]['en']);
  } else {
    return(TS.Dictionary[label][TS.currentLang]);
  }
};

/** LOAD CSS FILES 
 * @param {string} file stylesheet url
 * appends the link element {HTMLLinkElement} to the head tag.
 */
var loadCss = function(file){
  if(file!='' && file){
    if(!$('link[href="'+file+'"]') || $('link[href="'+file+'"]').length===0){
      $.trace.log('LOADING STYLESHEET: ' + file);
      var css = document.createElement('link');
        css.type = 'text/css';
        css.rel   = 'stylesheet';
        css.media = 'screen';
        css.href  = file+'?version='+TS.version;
      document.head.appendChild(css);
    }
  }
};

/** LOAD JAVASCRIPT FILES 
 * 
 * @param {string} file javascript url
 * @param {bool} external if true, it won't be treated as a module.
 * @returns {HTMLScriptElement} the script element.
 *  
 */
var loadScripts = function(file, external){
  if(file!='' && file){
    $.trace.log('LOADING SCRIPT: ' + file);
    var script = document.createElement('script');
      script.type = 'text/javascript';
      script.src = file+'?version='+TS.version;
      // script.onerror = onerror;
    document.head.appendChild(script);

    if (!external) {
      script.onload = function(){$(TS).trigger('moduleReady');};
    }
    return script;
  }
};



/** LOAD HTML TEMPLATES 
 *
 *  
 */

// TEST LOCAL STORAGE
var hasStorage = (function() {
  try {
    var mod = 'test';
    localStorage.setItem(mod, mod);
    localStorage.removeItem(mod);
    return true;
  } catch(e) {
    return false;
  }
}());

var loadTemplate = function(file){
  if(file!='' && file){
    var html = false;
    if(typeof localStorage[file+'_version'] === 'undefined'){
      localStorage[file+'_version'] = TS.version;
    }
    if(!hasStorage){
      $.ajax({
          url: file ,
          method: 'GET',
          dataType: 'html',
          async: false
        }).done(function(resp) {
            html = resp;
            $.trace.info('TEMPLATE "' + file + '" LOAD TYPE: XHR');
        }).error(function(){
          $.trace.error('Template: "' + file + '" does not exists');
          html = '<div class="error"><b>[ERROR]</b> Template: <b><i>"' + file + '"</i></b> not found!</div>'
        });
    } else {
      if((!localStorage[file] || localStorage[file]==='')  || TS.Config.forceTemplateDownload){
        $.ajax({
          url: file ,
          method: 'GET',
          dataType: 'html',
          async: false
        }).done(function(resp) {
          localStorage[file] = resp;
          localStorage[file+'_version'] = TS.version;
          html = resp;
          $.trace.info('TEMPLATE "' + file + '" LOAD TYPE: XHR');
        }).error(function(){
          $.trace.error('Template: "' + file + '" does not exists');
          html = '<div class="error"><b>[ERROR]</b> Template: <b><i>"' + file + '"</i></b> not found!</div>'
        });
      } else {
        var current = TS.version;
        var remote = parseInt(localStorage[file+'_version']);
        if( current > remote ){
          $.ajax({
            url: file ,
            method: 'GET',
            dataType: 'html',
            async: false
          }).done(function(resp) {
            localStorage[file] = resp;
            localStorage[file+'_version'] = TS.version;
            html = resp;
            $.trace.info('TEMPLATE "' + file + '" LOAD TYPE: XHR');
          }).error(function(){
            $.trace.error('Template: "' + file + '" does not exists');
            html = '<div class="error"><b>[ERROR]</b> Template: <b><i>"' + file + '"</i></b> not found!</div>'
          });
        } else {
          $.trace.info('TEMPLATE "' + file + '" LOAD TYPE: localStorage');
          html = localStorage[file];
        }
      } 
    }
    return html;
  }
};

/** RUN CUSTOM FUNCTIONS WITH FAILSAFE 
 *
 *  
 */
var run = function(fn){
  if(typeof(fn)=='function'){
    try{
      fn();
    } catch(err){
      if(err){
        // error handler !!! needs fix !!!
        $.trace.group('ERROR');
          TS.ErrorLog.push('@ ' + err);
          $.trace.error('@ ' + err);
        $.trace.groupEnd();
      }
    }
  }
};

/** PARSE QUERY STRING
 *
 */
$.getHash = function(hash) {
  if (!hash) {
    hash = window.location.hash;
  }
  hash = hash.slice(hash.indexOf('#') + 1);
  var hashVars = {};
  var hashParts = hash.split('&');
  for (var i = 0; i < hashParts.length; i++) {
    var parts = hashParts[i].split('=');
    if (parts.length > 1) {
        hashVars[parts[0]] = parts[1];
    } else if (parts[0].length > 0) {
      hashVars[parts[0]] = true;
    }
  }
  return hashVars;
};


/** TRACELOG CONSOLE 
 *
 *  
 */

$.trace = {

  isConsoleAvailable: true,
  consoleOpen : false,
  consoleText : '',
  consoleTextLine :  0,
  
  hide: function(){
    $('#traceConsole').css('display', 'none');
    $('#consoleOpenButton').css('display', 'block');
  },
  show: function(){
    $('#traceConsole').css('display', 'block');
    $('#consoleOpenButton').css('display', 'none');
  },
  
  console: function(msg, type, color){
    /*
    var recipe =  window.open('','RecipeWindow','width=700,height=520,scrollbars=1');
    var html = '<html><head><title>Trace Console</title></head><body style="padding:0;margin:0;background:#000;"><pre><div id="traceConsole" style="display: block;border:none; width: 100%; padding: 10px; background: #000; color: #ccc; font: normal 11px/18px Courier New; height: auto;"></div></pre></body></html>';
    */
    
    var consoleDiv = '<div onclick="$.trace.hide();" id="traceConsole" style="z-index:100;position:absolute;bottom:0;left:0;display: block;border:none; width: 40%; opacity:.80; height: 700px; overflow-y: scroll; padding: 10px; background: #000; color: #ccc; font: normal 10px/14px Courier New;"></div>';
    var consoleOpenButton = '<a id="consoleOpenButton" style="bottom:0;left:0;background:#000;display:none;width:40px;height:40px;text-align:center;color:#fff;font: normal 10px/40px Courier New;opacity:.80;z-index:1000000;position:absolute;" onclick="$.trace.show();">cnsl</a>';
    
    $.trace.consoleTextLine++;
    
    if(!type || type===''){
      type = '';
    } else {
      type = '['+ type +'] '
    }
    if(!color || color===''){
      color = 'color:#efefef'
    } else {
      color = 'color:'+color;
    }
    var lineNum = $.trace.consoleTextLine;
    if(lineNum<10){
      lineNum = '0' + lineNum;
    }
    
    $.trace.consoleText += '<a id="consoleLine'+lineNum+'"></a>'+  lineNum + '. <span style="'+color+'">' + msg +'</span><br />';
    var newLine = '<a id="consoleLine'+lineNum+'"></a>'+  lineNum + '. <span style="'+color+'">' + msg +'</span><br />';
    
    if(!$.trace.consoleOpen){
      $('#app-wrapper').append(consoleDiv);
      $('#app-wrapper').append(consoleOpenButton);
      $.trace.consoleOpen = true;
    }
    
    if($.trace.consoleOpen){
      // recipe.document.getElementById('traceConsole').innerHTML = $.trace.consoleText;
      // document.getElementById('traceConsole').innerHTML = $.trace.consoleText;
      document.getElementById('traceConsole').innerHTML = newLine + document.getElementById('traceConsole').innerHTML;
    }
    
  },
  
  log: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        $.trace.console(el, 'LOG');
      } else {
        alert('>>> TREADSTONE >>>  '+el);
      }
    }    
  },
  info: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        $.trace.console(el, 'INFO',  '#8bdfee');
      } else {
        alert('>>> TREADSTONE >>>  '+el);
      }
    }    
  },
  warn: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        $.trace.console(el, 'WARNING', '#eee48b');
      } else {
        alert('>>> TREADSTONE >>>  '+el);
      }
    }
  },
  error: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        $.trace.console(el, 'ERROR', '#ff0000');
      } else {
        alert('>>> TREADSTONE >>>  '+el);
      }
    }    
  },
  group: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        return false;
      } else {
        if(!console.group || typeof(console.group)!=='function'){
          return false;
        } else {
          console.group(el);
        }
      }
    }    
  },
  groupEnd: function(){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        return false;
      } else {
        if(!console.ggroupEnd || typeof(console.groupEnd)!=='function'){
          return false;
        } else {
          console.groupEnd();
        }
      }
    }    
  },
  time: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        return false;
      } else {
        if(!console.time || typeof(console.time)!=='function'){
          return false;
        } else {
          console.time(el);
        }
      }
    }    
  },
  timeEnd: function(el){
    if(TS.Config.DEBUG){
      if(!$.trace.isConsoleAvailable){
        return false;
      } else {
        if(!console.timeEnd || typeof(console.timeEnd)!=='function'){
          return false;
        } else {
          console.timeEnd(el);
        }
      }
    }    
  },
  dir: function(el){
    if(TS.Config.DEBUG){
       if(!$.trace.isConsoleAvailable){
         if(!JSON || typeof(JSON)==='undefined'){
           $.trace.error('Your browser does not support this function!');
         } else {
          $.trace.console(JSON.stringify(el), 'DIR', '#c4ff84');
         }
        } else {
          console.dir(el);
        }
    }    
  }
};


if(console || typeof(console)==='object'){
  $.trace.isConsoleAvailable = true; // true
} else {
  $.trace.isConsoleAvailable = false;
}


/** MAIN VIEW INTERFACE 
 *
 *  
 */
var View = function(template, target){
  
  var template = template;
  var targetArea = '#target';
  if(target && target!=''){
    targetArea = target;
  }
  
  /*
  var test = '{{$foreach}}';
  var reg = new RegExp(/\{\{([^}]+)\}\}/);
  var qwe = test.replace(/.*\{\{\$|\}\}/gi,'');
  */
  
  return{
    
    foreach: function(arr, item){
      
      
      
      var listTemplate = $(item);
      if (!listTemplate.length) {
        $.trace.error('core.foreach: can\'t find item.');
        return;
      }
        var target = $(item).parent();
        var targetId = item.replace('#','')+'-target';
        target.attr('id', targetId);

      $(item).remove();
      
      var foreachLength = arr.length;
      for(var i=0; i<foreachLength; i++){
        var item = arr[i];
        var replaceLength = arr[i].length;
        listTemplate.removeAttr('id');
        var lineTemplate = listTemplate.prop('outerHTML');
        for(var i2=0; i2<replaceLength; i2++){
          var toReplace = 'key='+item[i2]['key'];
          lineTemplate = lineTemplate.replace(toReplace, item[i2]['value']);
        }
        $(target).append(lineTemplate);
      }
    },
    
    set: function(tmp_var, var_value){
      var toReplace = '{{$'+tmp_var+'}}';
      var occ = template.split(toReplace).length-1;
      for(var i=0; i<occ; i++){
        template = template.replace(toReplace, var_value);
      }
    },
    display: function(replace){
      if(replace){
        $(targetArea).html('');
      }
      //return $(template).appendTo(targetArea).hide();
      return $(template).hide().appendTo(targetArea);
    }
  };
  
};


/** EVENTHANDLER, EVENT HISTORY AND EVENT DISPATCH 
 *
 *  
 */
TS.EventHandler = {
  History: []
};

$.prototype.addEvent = function(event, callback){
  
  if(typeof( TS.EventHandler.History[this[0].tagName+this.selector])!=='object'){
    TS.EventHandler.History[this[0].tagName+this.selector] = [];
  }
  if(typeof( TS.EventHandler.History[this[0].tagName+this.selector][event])!=='object'){
    TS.EventHandler.History[this[0].tagName+this.selector][event] = [];
  }
  TS.EventHandler.History[this[0].tagName+this.selector][event].push({'callback': callback});
  
  if(!callback || typeof(callback)!=='function'){
    $.trace.error('No callback defined!');
  }
  this.off(event).on(event, function(e){
    run(callback(this, e));
  })
  $.trace.info('Event: "' + event +'" registered on [' + this[0].tagName+this.selector + ']')
  return this;
};

$.prototype.fireEvent = function(event){
  try{
    var currentHistoryLength = TS.EventHandler.History[this[0].tagName+this.selector][event].length-1;
    TS.EventHandler.History[this[0].tagName+this.selector][event][currentHistoryLength].callback.call();
    return this;
  } catch(z){
    return false;
  };
};

$.prototype.removeLastEvent = function(event){
  var currentHistoryLength = TS.EventHandler.History[this[0].tagName+this.selector][event].length;
  TS.EventHandler.History[this[0].tagName+this.selector][event].pop();
  var newHistoryLength = TS.EventHandler.History[this[0].tagName+this.selector][event].length;
  var newEvent = TS.EventHandler.History[this[0].tagName+this.selector][event][newHistoryLength-1].callback;
  TS.EventHandler.History[this[0].tagName+this.selector][event].pop();
  $(this.selector).addEvent(event, newEvent);
  return this;
};

$.prototype.purgeEvent = function(event){
  try{
    delete TS.EventHandler.History[this[0].tagName+this.selector][event];
  } catch(e){};
  return this;
};


/**
* setTimeout is used to force the DOM change to async 
*/
var Preloader = {
  
  show: function(keepContents,doIt){
/*		if(doIt!==true)
			window.setTimeout("Preloader.show("+(keepContents ? 1 : 0)+",true)",1);
		else*/
			try{
				if(!keepContents)
					$(TS.Config.selectors.mainContentId).css('display', 'none');
    	  $(TS.Config.selectors.preloader).html($.translate('preloader_label'));
			  $(TS.Config.selectors.preloader).css('display', 'block');
			}catch(z){};
  },
  hide: function(doIt){
		if(doIt!==true)
			window.setTimeout("Preloader.hide(true)",100);
		else
			try{
        $(TS.Config.selectors.preloader).css('display', 'none');
			  $(TS.Config.selectors.mainContentId).css('display', 'block');
			}catch(z){};
  }
};



/** Initialize a module
 * @param {object} module The module object
 * sets system functions (init+show) + loads auto init if needed
 */
 TS.initModule = function(module)
 {

	/**
	* if it is a constructor, don't touch it!
	*/
	if(typeof(module)=='function')
	{
		return true;
	}
	
	
	/**
	* check requirements
	*/
	if(module.requires)
	{
		var dependencies = [];
		for(var i=0;i<module.requires.length;i++)
		{
			var modName = module.requires[i];
			if(!TS.Modules[modName])
			{
				loadScripts(TS.Config.Path.Modules+module.requires[i]+'/'+module.requires[i]+TS.Config.controllerSuffix);
				dependencies.push(modName);
			}
		}
		
		if(dependencies.length)
		{
				for(var j=0;j<TS.Include.length;j++)
				{
					if(TS.Include[j] == module.moduleName)
					{
						TS.Include = dependencies.concat(TS.Include.slice(j));
						break;
					}
				}
				TS.initModule.dependencies = dependencies.length;
				return false;
		}
	}

	/**
	* launch autoInit
	*/
	if(module.autoInit)
	{
		$.trace.info('MODULE: ' + (module.moduleName || 'undefined') + ' AUTOINIT: ' + module.autoInit + '');
		module.init();
	}
	
	return true;
};


/**
 * $.override
 * helps to avoid adding the same event handler more than once to a jQuery object
 * @param {string} event  tagName off The newEvent
 * @param {string} id  the name of the event
 * @param {function} handler the event handler - if not set, it will remove the event handling
 */
$.fn.extend({
  override : function(event,id,handler){
    this.each(function(){
      this.bindOnce || (this.bindOnce = {});

      if(this.bindOnce[event+id])
        $(this).off(event,this.bindOnce[event+id]);

      if(handler)
      {
        this.bindOnce[event+id] = handler;
        $(this).on(event,handler);
      }
      else delete this.bindOnce[event+id];
    });
  }
});
