<?php

session_start();
date_default_timezone_set('UTC');

if (!@$_SESSION['baconipsum']) {
  $_SESSION['baconipsum'] = implode(' ', 
    json_decode(file_get_contents('http://baconipsum.com/api/?type=meat-and-filler')));
  $_SESSION['baconIpsum'] = ucwords($_SESSION['baconipsum']);
  $_SESSION['baconWords'] = explode(' ', $_SESSION['baconIpsum']);
}

$baconipsum = $_SESSION['baconipsum'];
$baconIpsum = $_SESSION['baconIpsum'];
$baconWords = $_SESSION['baconWords'];

// Generate Results for +-90 days

$id = 1;
$time = strtotime(date('Y').'-'.date('m').'-'.date('d'));

if (!file_exists('results.dat')) {
  for ($date = $time - 60*60*24*25; 
       $date < $time;
       $date += rand(0, 6) * 60 * 30
  ) {
    $imageSize = rand(50, 500);

    $homeCrew = [];
    for ($i = 0; $i < 16; $i++) {
      $events = [];
      if (!rand(0, 6)) {
        $events[] = ['type' => 'yellowCard', 'minute' => rand(0, 90)];
      }

      if (!rand(0, 6)) {
        $events[] = ['type' => 'redCard', 'minute' => rand(0, 90)];
      }

      if (!rand(0, 6)) {
        $events[] = ['type' => 'score', 'minute' => rand(0, 90)];
      }

      if (!rand(0, 6)) {
        $events[] = ['type' => 'substitutionIn', 'minute' => rand(0, 90)];
      }

      if (!rand(0, 6)) {
        $events[] = ['type' => 'substitutionOut', 'minute' => rand(0, 90)];
      }

      $homeCrew[] = [
        'id' => rand(0, 10000),
        'number' => $i + 1,
        'name' => $baconWords[rand(0, sizeof($baconWords) - 1)]
                  . ' ' . $baconWords[rand(0, sizeof($baconWords) - 1)] 
                  . (!rand(0, 6) ? ' ' . $baconWords[rand(0, sizeof($baconWords) - 1)] : ''),
        'substitute' => $i >= 11, 
        'events' => $events
      ];
    }

    $awayCrew = [];
    for ($i = 0; $i < 16; $i++) {
      $events = [];
      if (!rand(0, 6)) {
        $events[] = ['type' => 'yellowCard', 'minute' => rand(0, 90)];
      }

      if (!rand(0, 6)) {
        $events[] = ['type' => 'redCard', 'minute' => rand(0, 90)];
      }

      if (!rand(0, 6)) {
        $events[] = ['type' => 'score', 'minute' => rand(0, 90)];
      }
      $awayCrew[] = [
        'id' => rand(0, 10000),
        'number' => $i + 1,
        'name' => $baconWords[rand(0, sizeof($baconWords) - 1)]
                  . ' ' . $baconWords[rand(0, sizeof($baconWords) - 1)] 
                  . (!rand(0, 6) ? ' ' . $baconWords[rand(0, sizeof($baconWords) - 1)] : ''),
        'substitute' => $i >= 11, 
        'events' => $events
      ];
    }

    $commentary = [];
    for ($i = 0; $i < 90; $i += rand(1, 5)) {
      $commentary[] = ['minute' => $i, 'text' => substr($baconipsum, rand(0, 50), rand(10, 100))];
    }

    $result = [
      'competitionID' => rand(1, 3),
      'kickoff' => $date,
      'id' => $id++,
      'homeTeam' => [
        'name' => @"{$baconWords[(0+2*$id)%100]} {$baconWords[(1+2*$id)%100]}",
        'thumb' => "http://baconmockup.com/$imageSize/$imageSize",
        'score' => rand(0, 15),
        'crew' => $homeCrew
      ],
      'awayTeam' => [
        'name' => @"{$baconWords[(3+2*$id)%100]} {$baconWords[(4+2*$id)%100]}",
        'thumb' => "http://placekitten.com/$imageSize/$imageSize",
        'score' => rand(0, 15),
        'crew' => $awayCrew
      ],
      'commentaries' => $commentary
    ];

    file_put_contents('results.dat', json_encode($result)."\n", FILE_APPEND);
  }
}

if (!file_exists('fixtures.dat')) {
  for ($date = $time; 
       $date < $time + 60*60*24*25;
       $date += rand(0, 6) * 60 * 30
  ) {
    $imageSize = rand(50, 500);
    $fixture = [
      'competitionID' => rand(1, 3),
      'kickoff' => $date,
      'id' => $id++,
      'homeTeam' => [
        'name' => @"{$baconWords[(0+2*$id)%100]} {$baconWords[(1+2*$id)%100]}",
        'thumb' => "http://baconmockup.com/$imageSize/$imageSize",
      ],
      'awayTeam' => [
        'name' => @"{$baconWords[(3+2*$id)%100]} {$baconWords[(4+2*$id)%100]}",
        'thumb' => "http://placekitten.com/$imageSize/$imageSize",
      ]
    ];
    file_put_contents('fixtures.dat', json_encode($fixture)."\n", FILE_APPEND);
  }
}

if (!file_exists('news.dat')) {
  for ($i = 0; $i < rand(20, 100); $i++) {
    $imageSize = rand(200, 2000);
    $r1 = rand(30, 150);
		$rTitle = rand(6, 30);
    $newsItem = [
      'channelID' => rand(1, 4),
      'picture' => rand(0, 1) ? "http://placekitten.com/$imageSize/$imageSize" :
                                "http://baconmockup.com/$imageSize/$imageSize",
      'title' => substr($baconIpsum, $rTitle, $rTitle*2),
      'lead' => substr($baconIpsum, $r1, $r1*5),
      'body' => substr($baconIpsum, $r1, $r1*15)                  
    ];
    $newsItem['thumbnail'] = $newsItem['picture'];
    file_put_contents('news.dat', json_encode($newsItem)."\n", FILE_APPEND);
  }
}

$_SESSION['last_id'] = session_id();